C  *DECK BROWN
      SUBROUTINE BROWN
      INCLUDE 'STATUS'
      INCLUDE 'HEADST'
      INCLUDE 'MODELC'
      INTEGER IVALUE,YEAR,I,J,II,JJ,TYPE
      CHARACTER*80 STRNG(20)
      EXTERNAL IVALUE
      CHARACTER CARDIM*80
C
C   DEFINITION OF S(I)'S
C
C   S(1) TO S(NCOHT) - FIRST YEAR RECOVERY RATES
C   S(NCOHT+1) TO S(NCOHT+NCLASS(1)-1) - SECOND+ YEAR RECOVERY RATES
C   S(NCOHT+NCLASS(1)) TO S(NPAR) - SURVIVAL RATES
C
      NSIG=5
      IISTR=0
      MAXFN=200*NEST
      SINTRN=.TRUE.
      NOTRAN=.FALSE.
      NOVAR=.FALSE.
C     TAKE CARE OF INFORMATION ON PROC CARD.
      DO 2 I=3,LSTWRD
         IF (WORDS(I).EQ.'NSIG') THEN
            NSIG = IVALUE(WORDS(I+2))
         ELSE IF (WORDS(I).EQ.'MAXFN') THEN
            MAXFN = IVALUE(WORDS(I+2))
         ELSE IF (WORDS(I).EQ.'NOVAR') THEN
            NOVAR = .TRUE.
         ELSE IF (WORDS(I).EQ.'TRANSFORM') THEN
            IF (WORDS(I+2).EQ.'NOSIN') THEN
               SINTRN=.FALSE.
            ELSE IF (WORDS(I+2).EQ.'NO') THEN
               NOTRAN=.TRUE.
            ENDIF
         ENDIF
    2    CONTINUE
C
C   READ INPUT BROWNIE FORMATTED INPUT
C
      CALL GETCMD
      CARDIM=STRING(LCMDST:LCMDED-1)
      INDENT=-3
      IF (CARDIM.NE.' ') THEN
         TITSTR=CARDIM
      ENDIF
      CALL GETCMD
      II=1
      IF (WORDS(II).EQ.',') II=II+1
      NCOHT=IVALUE(WORDS(II))
      II=II+1
      IF (WORDS(II).EQ.',') II=II+1
      NCLASS(1)=IVALUE(WORDS(II))
      II=II+1
      IF (WORDS(II).EQ.',') II=II+1
      YEAR=IVALUE(WORDS(II))
      II=II+1
      IF (WORDS(II).EQ.',') II=II+1
      TYPE=IVALUE(WORDS(II))
      IF (TYPE .NE. 1) THEN
         CALL ERROR('PROC BROWNIE not yet able to handle TYPE .NE. 1')
      ENDIF
      NPAR=NCOHT+NCLASS(1)*2-2
      DO 5 I=2,NCOHT
         NCLASS(I)=NCLASS(I-1)-1
 5       CONTINUE
      DO 10 I=1,NCOHT
         CALL GETCMD
         II=0
         DO 10 J=1,NCLASS(I)
            II=II+1
            IF (WORDS(II).EQ.',') II=II+1
 10         OBS(J,I)=VALUE(WORDS(II))
      CALL GETCMD
      II=0
      DO 15 I=1,NCOHT
         II=II+1
         IF (WORDS(II).EQ.',') II=II+1
 15      N(I)=VALUE(WORDS(II))
      CALL GETCMD
C
C   CONSTRUCT CELL PROBABILITY EXPRESSIONS
C
C   OPEN UP DIRECT ACCESS FILE TO HOLD CHARACTER EXPRESSIONS FOR
C   CELL PROBABILITIES
      CLOSE(UNIT=SYSTP1,STATUS='DELETE')
      OPEN(UNIT=SYSTP1,ACCESS='DIRECT',FORM='FORMATTED',
     1   RECL=MAXCHS,STATUS='SCRATCH')
      DO 20 I=1,NCOHT
         CALL LINCHK(1)
         WRITE(UNIT=SYSOUT,FMT='(''   COHORT = '',I6,
     1      ''  /* Banded in '',I4,'' */;'')') N(I),YEAR+I-1
         DO 25 J=1,NCLASS(I)
            SFUNCS=' '
            IF (J.EQ.1) THEN
               WRITE(SFUNCS,FMT='(2HS(,I2.2,1H))') I
            ELSE
               WRITE(SFUNCS,FMT='(2HS(,I2.2,1H),20(:3H*S(,I2.2,1H))
     1             )') (JJ+NCOHT+NCLASS(1)-1,JJ=I,I+J-2),NCOHT+I+J-2
            ENDIF
            II=INDEX(SFUNCS,' ')
            SFUNCS(II:II)=';'
            CALL LINCHK(1)
            WRITE(UNIT=SYSOUT,FMT='(3X,I6,1H:,A)')
     1         OBS(J,I),SFUNCS(1:71)
            IF (II.GT.71) THEN
               DO 35 JJ=72,II,80
                  CALL LINCHK(1)
                  WRITE(UNIT=SYSOUT,FMT='(1X,A)') 
     1               SFUNCS(JJ:JJ+79)
 35               CONTINUE
            ENDIF
            SFUNCS(II:II)=' '
            WRITE(UNIT=SYSTP1,REC=(I-1)*MXCLAS+J,FMT='(A)') SFUNCS
 25         CONTINUE
 20      CONTINUE
C   NOTE THAT EACH VALUE OF NCLASS(I) GETS INCREMENTED BY ONE IN
C   MODOUT TO HANDLE THE CLASS OF BIRDS THAT ARE NEVER RECOVERED.
      CALL MODOUT(IISTR,STRNG)
C
C   MODEL 3 -- CONSTANT SURVIVAL AND RECOVERY RATES
C
      DO 40 I=1,NPAR
         POINTL(I)=0
         POINTU(I)=0
         PARL(I)=0.0
         PARU(I)=1.0
 40      CONTINUE
      NFIX=0
      NEST=2
      NCONS=NPAR-2
      PAR(1)=DBLE(OBS(1,1)+1)/DBLE(N(1))
      DO 70 I=1,NCOHT+NCLASS(1)-2
         PAR(I)=PAR(1)
         POINT(I)=1
         SLABEL(I)='CONSTANT RECOVERY RATE'
 70      CONTINUE
      PAR(NCOHT+NCLASS(1)-1)=0.5
      DO 75 I=NCOHT+NCLASS(1)-1,NPAR
         PAR(I)=PAR(NCOHT+NCLASS(1)-1)
         POINT(I)=NCOHT+NCLASS(1)-1
         SLABEL(I)='CONSTANT SURVIVAL RATE'
 75      CONTINUE
      MODNUM=1
      XLLVAL(MODNUM)=-1.E20
      NDFSAV(MODNUM)=0
      MODGOF(MODNUM)=0.
      MODNAM(MODNUM)='MODEL_3'
      CALL CONSRT(2)
      NOTRAN=.FALSE.
      CALL HEADNG
      CALL LINCHK(3)
      WRITE(UNIT=SYSOUT,FMT='(/11X,A/)')
     1   '- - -  ESTIMATION FOR '//MODNAM(MODNUM)//'- - -'
      CALL ESTMAT(2)
C
C   MODEL 2 -- CONSTANT SURVIVAL RATE BUT TIME-SPECIFIC RECOVERY RATES
C
      NFIX=0
      NEST=NCLASS(1)
      NCONS=NPAR-NEST
      READ(UNIT=SYSTP2,REC=1) (PAR(I),I=1,NPAR)
      DO 60 I=1,NCOHT
         POINT(I)=I
         POINT(I+NCOHT)=I+1
         WRITE(SLABEL(I),FMT='(A,I4)') 'RECOVERY RATE FOR ',YEAR+I-1
         WRITE(SLABEL(I+NCOHT),FMT='(A,I4)') 'RECOVERY RATE FOR ',YEAR+I
 60      CONTINUE
      DO 65 I=NCOHT*2,NCOHT+NCLASS(1)-2
         POINT(I)=I
         WRITE(SLABEL(I),FMT='(A,I4)') 'RECOVERY RATE FOR ',YEAR+I-NCOHT
 65      CONTINUE
      DO 67 I=NCOHT+NCLASS(1)-1,NPAR
         POINT(I)=NCOHT+NCLASS(1)-1
         SLABEL(I)='CONSTANT SURVIVAL RATE'
 67      CONTINUE
      MODNUM=2
      XLLVAL(MODNUM)=-1.E20
      NDFSAV(MODNUM)=0
      MODGOF(MODNUM)=0.
      MODNAM(MODNUM)='MODEL_2'
      CALL CONSRT(2)
      NOTRAN=.FALSE.
      CALL HEADNG
      CALL LINCHK(3)
      WRITE(UNIT=SYSOUT,FMT='(/11X,A/)')
     1   '- - -  ESTIMATION FOR '//MODNAM(MODNUM)//'- - -'
      CALL ESTMAT(2)
C
C   MODEL 1 -- TIME-SPECIFIC SURVIVAL AND RECOVERY RATES
C
      NFIX=NCLASS(1)-1-NCOHT
      NCONS=NCOHT-1
      NEST=NPAR-NFIX-NCONS
      READ(UNIT=SYSTP2,REC=2) (PAR(I),I=1,NPAR)
      DO 54 I=NCOHT*2,NCOHT+NCLASS(1)-2
         WRITE(SLABEL(I),FMT='(A,I4,1H-,I4,A,I4)') 'SURVIVAL FOR ',
     1      YEAR+NCOHT-1,YEAR+I-NCOHT-1,' AND RECOVERY FOR ',
     2      YEAR+I-NCOHT
 54      CONTINUE
      DO 55 I=NCOHT+NCLASS(1)-1,NPAR
         POINT(I)=I
         WRITE(SLABEL(I),FMT='(A,I4)') 'SURVIVAL FOR YEAR ',
     1      YEAR+I-NCOHT-(NCLASS(1)-1)
 55      CONTINUE
      DO 57 I=NPAR-(NCLASS(1)-2-NCOHT),NPAR
         POINT(I)=-I
         PAR(I)=1.0
         PARL(I)=1.0
         PARU(I)=1.0
         SLABEL(I)(24:38)='(UNESTIMATABLE)'
 57      CONTINUE
      MODNUM=3
      XLLVAL(MODNUM)=-1.E20
      NDFSAV(MODNUM)=0
      MODGOF(MODNUM)=0.
      MODNAM(MODNUM)='MODEL_1'
      CALL CONSRT(2)
      NOTRAN=.FALSE.
      CALL HEADNG
      CALL LINCHK(3)
      WRITE(UNIT=SYSOUT,FMT='(/11X,A/)')
     1   '- - -  ESTIMATION FOR '//MODNAM(MODNUM)//'- - -'
      CALL ESTMAT(2)
C
C   MODEL 0 -- TIME-SPECIFIC SURVIVAL AND RECOVERY RATES, WITH
C              BOTH FIRST-YEAR RECOVERY RATES AND RECOVERY RATES FOR
C              PREVIOUSLY BANDED BIRDS
C
      NFIX=NCLASS(1)-1-NCOHT
      NCONS=0
      NEST=NPAR-NFIX
      READ(UNIT=SYSTP2,REC=3) (PAR(I),I=1,NPAR)
      DO 44 I=1,NEST
         PARL(I)=0.0
         PARU(I)=1.0
         POINT(I)=I
         POINTL(I)=0
         POINTU(I)=0
 44      CONTINUE
      DO 45 I=NEST+1,NPAR
         PAR(I)=1.0
         PARL(I)=1.0
         PARU(I)=1.0
         POINT(I)=-I
 45      CONTINUE
      DO 46 I=1,NCOHT
         CARDIM=SLABEL(I)(1:23)
 46      SLABEL(I)='FIRST YEAR '//CARDIM(1:23)
      DO 47 I=NCOHT+1,NCOHT*2-1
         CARDIM=SLABEL(I)(1:23)
 47      SLABEL(I)='SECOND+ YEAR '//CARDIM(1:23)
      MODNUM=4
      XLLVAL(MODNUM)=-1.E20
      NDFSAV(MODNUM)=0
      MODGOF(MODNUM)=0.
      MODNAM(MODNUM)='MODEL_0'
      CALL CONSRT(2)
      NOTRAN=.FALSE.
      CALL HEADNG
      CALL LINCHK(3)
      WRITE(UNIT=SYSOUT,FMT='(/11X,A/)')
     1   '- - -  ESTIMATION FOR '//MODNAM(MODNUM)//'- - -'
      CALL ESTMAT(2)
      RETURN
 30   CALL ERROR('Error in reading: '//CARDIM)
      RETURN
      END

