C  *DECK CONSRT
      SUBROUTINE CONSRT(INTRY)
      INCLUDE 'STATUS'
      INCLUDE 'MODELC'
      DOUBLE PRECISION TEMP,VALUE
      LOGICAL INEQLY
      INTEGER INTRY,VERIFY,NPARM,I,J,N1,N2,N3
      EXTERNAL VERIFY,NPARM
      IF (INTRY.EQ.2) GO TO 5
      INEQLY=.FALSE.
      NCONS=0
      NFIX=0
   10 CALL GETCMD
  5   IF (WORDS(1).EQ.'PROC' .OR. WORDS(1).EQ.'INITIAL') THEN
C        SET NUMBER OF PARAMETERS TO BE ESTIMATED
         NEST=NPAR-NCONS-NFIX
         IF (BMDCAL) RETURN
C        MOVE ALL FIXED PARAMETERS TO END OF PARAMETER LIST
         IF(NFIX.GT.0) THEN
         N1=NPAR-NFIX
         I=1
   30    CONTINUE
            IF(POINT(I).EQ.(-I)) THEN
               N1=N1+1
               DO 15 J=N1,NPAR
                  IF(POINT(J).NE.(-J)) GO TO 20
   15             CONTINUE
               CALL WARN('All parameters are fixed.  '//
     1                   'Nothing to estimate.')
               RETURN
   20          N1=J
               TEMP=PAR(I)
               PAR(I)=PAR(N1)
               PAR(N1)=TEMP
               TEMP=PARL(I)
               PARL(I)=PARL(N1)
               PARL(N1)=TEMP
               TEMP=PARU(I)
               PARU(I)=PARU(N1)
               PARU(N1)=TEMP
               POINT(I)=-N1
C              ADJUST ALL OTHER POINTERS
               IF (POINT(N1).EQ.N1) THEN
                  DO 25 J=1,NPAR
                     IF (POINT(J).EQ.N1) THEN
                        POINT(J)=I
                     ENDIF
                     IF (POINTL(J).EQ.N1) THEN
                        POINTL(J)=I
                     ENDIF
                     IF (POINTU(J).EQ.N1) THEN
                        POINTU(J)=I
                     ENDIF
   25                CONTINUE
                  ENDIF
            ENDIF
            I=I+1
            IF(I.LE.(NPAR-NFIX)) GO TO 30
         ENDIF
C        IF THERE ARE PARAMETERS SET EQUAL TO EACH OTHER,
C        PACK THEM INTO THE FIRST NEST LOCATIONS OF PAR, PARL, AND PARU.
         IF (NCONS.GT.0) THEN
C        FIND A HOLE IN PAR AND SHUFFLE DOWN REMAINDER OF PAR TO FILL
            DO 35 I=1,NEST
   55          DO 40 J=1,NPAR
                  IF(POINT(J).EQ.I) GO TO 35
   40             CONTINUE
C              NO POINTER TO PAR(I) WAS FOUND, SO SHUFFLE
C              THE PORTIONS OF PAR, PARL, AND PARU ABOVE I BUT
C              UNDER THE FIXED PARAMETERS, DOWN ONE
C              LOCATION AND DO SEARCH OVER.
               DO 45 J=1,NPAR
                  IF (POINT(J).GT.I) THEN
                     POINT(J)=POINT(J)-1
                  ENDIF
                  IF (POINTL(J).GT.I) THEN
                     POINTL(J)=POINTL(J)-1
                  ENDIF
                  IF (POINTU(J).GT.I) THEN
                     POINTU(J)=POINTU(J)-1
                  ENDIF
   45             CONTINUE
               DO 50 J=I+1,NPAR-NFIX
                  PAR(J-1)=PAR(J)
                  PARL(J-1)=PARL(J)
                  PARU(J-1)=PARU(J)
   50             CONTINUE
               GO TO 55
   35       CONTINUE
         ENDIF
         IF (INEQLY) THEN
            CALL WARN('Inequality constraints may cause optimization'//
     1      ' errors.')
            CALL WARN('Verify output for correctness.')
         ENDIF
         RETURN
      ELSE IF (WORDS(1)(1:1).EQ.'S') THEN
         INDENT=3
         N1=NPARM(WORDS(1))
         IF(WORDS(2).EQ.'=') THEN
            IF(WORDS(3)(1:1).EQ.'S') THEN
               N2=NPARM(WORDS(3))
               POINT(MAX(N1,N2))=POINT(MIN(N1,N2))
               NCONS=NCONS+1
            ELSE
               PAR(N1)=VALUE(WORDS(3))
               PARL(N1)=PAR(N1)
               PARU(N1)=PAR(N1)
               POINT(N1)=-N1
               NFIX=NFIX+1
            ENDIF
         ELSE IF(WORDS(2).EQ.'<') THEN
            IF(WORDS(3)(1:1).EQ.'S') THEN
               N2=NPARM(WORDS(3))
               POINTU(N1)=N2
               INEQLY=.TRUE.
               IF(WORDS(4).EQ.'<') THEN
                  IF(WORDS(5)(1:1).EQ.'S') THEN
                     N3=NPARM(WORDS(5))
                     POINTU(N2)=N3
                     INEQLY=.TRUE.
                  ELSE
                     PARU(N2)=VALUE(WORDS(5))
                  ENDIF
               ELSE IF(WORDS(4).NE.' ') THEN
                  CALL ERROR('Last of constraint incorrect.')
               ENDIF
            ELSE IF(VERIFY(WORDS(3),'0123456789.+-ED ').EQ.0) THEN
               PARU(N1)=VALUE(WORDS(3))
            ELSE
               CALL ERROR('Unrecognized CONSTRAINT.')
            ENDIF
         ELSE IF (WORDS(2).EQ.'>') THEN
            IF(WORDS(3)(1:1).EQ.'S') THEN
               N2=NPARM(WORDS(3))
               POINTL(N1)=N2
               INEQLY=.TRUE.
               IF(WORDS(4).EQ.'>') THEN
                  IF(WORDS(5)(1:1).EQ.'S') THEN
                     N3=NPARM(WORDS(5))
                     POINTL(N2)=N3
                     INEQLY=.TRUE.
                  ELSE
                     PARL(N2)=VALUE(WORDS(5))
                  ENDIF
               ELSE IF(WORDS(4).NE.' ') THEN
                  CALL ERROR('LAST OF CONSTRAINT INCORRECT')
               ENDIF
            ELSE IF(VERIFY(WORDS(3),'0123456789.+-ED ').EQ.0) THEN
               PARL(N1)=VALUE(WORDS(3))
            ELSE
               CALL ERROR('Unrecognized CONSTRAINT.')
            ENDIF
         ENDIF
      ELSE IF (VERIFY(WORDS(1),'0123456789.+-ED ').EQ.0) THEN
         IF(WORDS(2).EQ.'<') THEN
            IF(WORDS(3)(1:1).EQ.'S') THEN
               N2=NPARM(WORDS(3))
               PARL(N2)=VALUE(WORDS(1))
               IF(WORDS(4).EQ.'<') THEN
                  IF(WORDS(5)(1:1).EQ.'S') THEN
                     N3=NPARM(WORDS(5))
                     POINTU(N2)=N3
                     INEQLY=.TRUE.
                  ELSE
                     PARU(N2)=VALUE(WORDS(5))
                  ENDIF
               ELSE IF(WORDS(4).NE.' ') THEN
                  CALL ERROR('LAST OF CONSTRAINT STATEMENT INCORRECT')
               ENDIF
            ELSE
               CALL ERROR('Unrecognized CONSTRAINT.')
            ENDIF
         ELSE IF(WORDS(2).EQ.'>') THEN
            IF(WORDS(3)(1:1).EQ.'S') THEN
               N2=NPARM(WORDS(3))
               PARU(N2)=VALUE(WORDS(1))
               IF(WORDS(4).EQ.'>') THEN
                  IF(WORDS(5)(1:1).EQ.'S') THEN
                     N3=NPARM(WORDS(5))
                     POINTL(N2)=N3
                     INEQLY=.TRUE.
                  ELSE
                     PARL(N2)=VALUE(WORDS(5))
                  ENDIF
               ELSE IF(WORDS(4).NE.' ') THEN
                  CALL ERROR('LAST OF CONSTRAINT STATEMENT INCORRECT')
               ENDIF
            ELSE
               CALL ERROR('Unrecognized CONSTRAINT.')
            ENDIF
         ELSE
            CALL ERROR('Unrecognized CONSTRAINT.')
         ENDIF
      ELSE
         CALL ERROR ('Unrecognized CONSTRAINT.')
      ENDIF
      GO TO 10
      END
