      SUBROUTINE DOTEST
      INCLUDE 'STATUS'
      INCLUDE 'MODELC'
      INTEGER NDF,IER,I,INUM,IDEM,J,ISV(MAXMOD),SUMN
      DOUBLE PRECISION CHISQ,PROB,AIC(MAXMOD,4),TMP
      CHARACTER*10 CTMP
      II=0
      C=0
C               MGM=MODEL NUMBER OF MOST-GENERAL-MODEL
      MGM=1
c                    sum cohorts for corrected AIC
      SUMN=0
      DO I=1,NCOHT
        SUMN=SUMN+N(I)
      ENDDO
C
      IFLG=0
      IPTR=0
      DO I=1,LSTWRD
        if(words(I) .eq. 'AICSAVE')IFLG=1
        if(words(I) .eq. 'SORTBY')IPTR=I
        if(words(I) .eq. 'C')C=VALUE(WORDS(I+2))
      ENDDO
      ISRT=4
      IF(IPTR.GT.0.AND.IPTR.LT.LSTWRD)THEN
        IF(WORDS(IPTR+1).EQ.'AIC')ISRT=1
        IF(WORDS(IPTR+1).EQ.'AICC')ISRT=2
        IF(WORDS(IPTR+1).EQ.'QAIC')ISRT=3
        IF(WORDS(IPTR+1).EQ.'QAICC')ISRT=4
      ENDIF
      IF(IFLG.EQ.1)THEN
C                   READ AIC'S FROM PREV RUN MODELS
         OPEN(UNIT=22,FILE=WORDS(5))
         I=MODNUM
         DO J=1,MAXMOD
            I=I+1
            READ(22,4,END=8)MODNAM(I),AIC(I,1),XLLVAL(I),NDFSAV(I),
     3         NESTSV(I),MODGOF(I),GOFG(I),GOFDF(I)
    4       format(1X,A10,2X,F16.2,2X,G14.8,I5,5X,i5,4X,F6.4,G14.8,I6)
            II=0
            DO K=1,MODNUM
               IF(MODNAM(I).EQ.MODNAM(K))II=K
            END DO
            IF(II.GT.0)I=I-1
         END DO
    8    CLOSE(22)
         II=1
C                 OPEN AIC FILE FOR OUTPUT 
         OPEN(UNIT=22,FILE=WORDS(5))
         MODNUM=I-1
      ENDIF
      CALL GETCMD
      IF (MODNUM.LE.1) THEN
      CALL WARN('Not enough PROC ESTIMATE statements to generate'//
     1   ' models for testing.')
      ELSE
C                       COMPUTE AIC & CORRECTED AIC (AIC(*,2))
         DO I=1,MODNUM
           ISV(I)=I
           AIC(I,1)= -2.*XLLVAL(I)+2*NESTSV(I)
           AIC(I,2)=AIC(I,1)+2*NESTSV(I)*(NESTSV(I)+1)/
     /                           FLOAT(SUMN-NESTSV(I)-1)
           IF(NESTSV(I).GT.NESTSV(MGM))MGM=I
         END DO
         IF(C.LT.1..AND.GOFDF(MGM).NE.0)C=GOFG(MGM)/FLOAT(GOFDF(MGM))
         IF(C.LT.1.)C=1
C                       COMPUTE QUASI-AIC (AIC(*,3)) & CORRECTED QAIC (AIC(*,4))
         WRITE(SYSOUT,*) ' '
         WRITE(SYSOUT,*) 'Modified AIC calculations: (see "Model Selecti
     xon and Inference:'
         WRITE(SYSOUT,*) ' A Practical Information Theoretic Approach" b
     Xy K. P. Burnham'
         WRITE(SYSOUT,*) ' and David R. Anderson, 1998)'
         WRITE(SYSOUT,*) ' '
         WRITE(SYSOUT,*) '  Most General Model:',MODNAM(MGM)
         WRITE(SYSOUT,*) '  n=',SUMN,' c=', C
         WRITE(SYSOUT,*) '  Model   K    AIC         AICc',
     ,     '         QAIC         QAICc'
         DO I=1,MODNUM
           AIC(I,3)=-2.*XLLVAL(I)/C+2.*NESTSV(I)
           AIC(I,4)=AIC(I,3)+2*NESTSV(I)*(NESTSV(I)+1)/
     /                           FLOAT(SUMN-NESTSV(I)-1)
           WRITE(SYSOUT,55) I,NESTSV(I),(AIC(I,J),J=1,4)
   55      FORMAT(I4,I7,5(1X,G12.6))
         END DO
         WRITE(SYSOUT,*)' '
C                       SORT MODELS BY AIC
         DO I=1,MODNUM-1
            LO=I
            DO J=I+1,MODNUM
               IF(AIC(J,ISRT).LT.AIC(LO,ISRT))LO=J
            END DO
            ITMP=ISV(I)
            ISV(I)=ISV(LO)
            ISV(LO)=ITMP
            CTMP=MODNAM(I)
            MODNAM(I)=MODNAM(LO)
            MODNAM(LO)=CTMP
            TMP=XLLVAL(I)
            XLLVAL(I)=XLLVAL(LO)
            XLLVAL(LO)=TMP
            DO J=1,4
              TMP=AIC(I,J)
              AIC(I,J)=AIC(LO,J)
              AIC(LO,J)=TMP
            END DO
            ITMP=NDFSAV(I)
            NDFSAV(I)=NDFSAV(LO)
            NDFSAV(LO)=ITMP
            ITMP=NESTSV(I)
            NESTSV(I)=NESTSV(LO)
            NESTSV(LO)=ITMP
            TMP=MODGOF(I)
            MODGOF(I)=MODGOF(LO)
            MODGOF(LO)=TMP
            TMP=GOFG(I)
            GOFG(I)=GOFG(LO)
            GOFG(LO)=TMP
            ITMP=GOFDF(I)
            GOFDF(I)=GOFDF(LO)
            GOFDF(LO)=ITMP
         END DO
C
         CALL LINCHK(5+MODNUM)
         WRITE(UNIT=SYSOUT,FMT=
     1      '(//2X,8x,5X,4hLog-/
     2          2X,8HSubmodel,2X,17Hlikelihood    NDF,
     3          4X,3HAIC,7X,5HG-O-F,4X,4HAICC,6X,4HQAIC,6X,5HQAICC)')
         WRITE(UNIT=SYSOUT,FMT=
     1      '(1X,9(1H-),2X,10(1H-),4X,3(1H-),1X,
     2        9(1H-),4X,6(1H-),2x,7(1h-),3X,7(1h-),3X,7(1h-))')
         DO 10 I=1,MODNUM
            if(II.GT.0)
     1       WRITE(22,4)MODNAM(I),AIC(I,1),XLLVAL(I),NDFSAV(I),
     3         NESTSV(I),MODGOF(I),GOFG(I),GOFDF(I)
            WRITE(UNIT=SYSOUT,FMT='(I2,1X,A10,1X,G10.4,I5,2X,
     1         G11.5,1X,F6.4,1X,3(1x,G9.4))')
     2         ISV(I),MODNAM(I),XLLVAL(I),NDFSAV(I),AIC(I,1),MODGOF(I),
     3         AIC(I,2),AIC(I,3),AIC(I,4)
   10       CONTINUE
      CLOSE(22,STATUS='KEEP')
      CALL LINCHK(5)
      WRITE(UNIT=SYSOUT,FMT='(/21X,A)')
     1           'Likelihood Ratio Tests Between Models'
      WRITE(UNIT=SYSOUT,FMT='(1X,A)')
     1   ' General              Reduced                           Degree
     Xs   Pr(Larger ',
     2   ' Submodel             Submodel              Chi-square  Freedo
     Xm  Chi-square)',
     3   '----------           ----------             ----------  ------
     X-  -----------'
         DO 30 I=1,MODNUM-1
C           IF (NDFSAV(I).EQ.0) GO TO 30
            DO 20 J=I+1,MODNUM
C              IF (NDFSAV(J).EQ.0) GO TO 20
               IF (NDFSAV(I).GT.NDFSAV(J)) THEN
                  INUM=I
                  IDEM=J
               ELSE IF (NDFSAV(I).LT.NDFSAV(J)) THEN
                  INUM=J
                  IDEM=I
               ELSE
                  GO TO 20
               ENDIF
               CHISQ=-2.*(XLLVAL(INUM)-XLLVAL(IDEM))
               NDF=NDFSAV(INUM)-NDFSAV(IDEM)
               IF (CHISQ.GT.0. .AND. NDF.GT.0) THEN
                  CALL CDTR(CHISQ,NDF,PROB,IER)
                  IF (IER.NE.0) THEN
                     CALL WARN('ERROR with chi-square probability.')
                  ENDIF
                  PROB=1.-PROB
               ELSE
                  PROB=1.
                  CHISQ=0.
               ENDIF
               CALL LINCHK(1)
               WRITE(UNIT=SYSOUT,FMT=
     1            '(1X,A10,12X,A10,12X,F10.3,4X,I3,7X,F6.4)')
     3            MODNAM(IDEM),MODNAM(INUM),CHISQ,NDF,PROB
   20       CONTINUE
   30    CONTINUE
      ENDIF
      MODNUM=0
      CALL LINCHK(2)
      CALL WARN('Sequence of models reinitialized to zero.')
      RETURN
      END

