      SUBROUTINE ESTMAT(INTRY)
      INCLUDE 'STATUS'
      INCLUDE 'MODELC'
      DOUBLE PRECISION H(MAXPR2),G(MAXPAR),W(MAXPAR,3),PPAR(MAXPAR)
      DOUBLE PRECISION PARPI(MXCLAS,MAXCHT,MAXPAR),VCMAT(MAXPAR,MAXPAR)
      DOUBLE PRECISION BNDL,BNDU,LCI,UCI
      DOUBLE PRECISION EXPECT(MXCLAS),OBSERV(MXCLAS),DLGAMA,SEPAR,
     1      CHISQ,CHISQP,CHISQI,GCONTR,CONTRB,PROB,SS,XLL,PARVAL
      INTEGER NDF,NDFP,NDFI,INTRY
      EQUIVALENCE (PARPI(1,1,1),G),(PARPI(1,1,2),W),(PARPI,VCMAT),
     1   (PARPI,EXPECT),(PARPI(1,2,1),OBSERV)
      COMMON /NOLABL/ H,PPAR,PARPI
      CHARACTER LOWBND*8,UPPBND*8,NOTE*15
      INTEGER IVALUE,IJOBOP,IJOBIV,IER,I,J,K,L,M
      EXTERNAL EST,IVALUE,SS,DLGAMA
      DATA IJOBOP/0/, IJOBIV/1/
      IF (INTRY.EQ.2) GO TO 10
      IF (INTRY.EQ.3) GO TO 16
      MODNUM=MODNUM+1
      IF (MODNUM.GT.MAXMOD) THEN
         CALL ERROR('Number of PROC ESTIMATE calls exceeds dimensions.')
      ENDIF
      XLLVAL(MODNUM)=-1.E20
      NDFSAV(MODNUM)=0
      MODGOF(MODNUM)=0.
      WRITE(MODNAM(MODNUM),'(8HSUBMODEL,I2)') MODNUM
      NSIG=5
      MAXFN=1000
      NOTRAN=.FALSE.
      SINTRN=.TRUE.
      NOVAR=.FALSE.
      NOBINC=.FALSE.
C     TAKE CARE OF INFORMATION ON PROC CARD.
      DO 2 I=3,LSTWRD
         IF (WORDS(I).EQ.'NSIG') THEN
            NSIG = IVALUE(WORDS(I+2))
         ELSE IF (WORDS(I).EQ.'MAXFN') THEN
            MAXFN = IVALUE(WORDS(I+2))
         ELSE IF (WORDS(I).EQ.'NAME') THEN
            MODNAM(MODNUM)=WORDS(I+2)
            write(0,*)'model=',modnam(modnum)
         ELSE IF (WORDS(I).EQ.'NOVAR' .OR. WORDS(I).EQ.'NOVC') THEN
            NOVAR=.TRUE.
         ELSE IF (WORDS(I).EQ.'NOBINCOF' .OR. WORDS(I).EQ.'NOBINOMIAL')
     1      THEN
            NOBINC=.TRUE.
         ELSE IF (WORDS(I).EQ.'TRANSFORM') THEN
            IF (WORDS(I+2).EQ.'ABS') THEN
               SINTRN=.FALSE.
            ELSE IF (WORDS(I+2)(1:2).EQ.'NO') THEN
               NOTRAN=.TRUE.
            ENDIF
         ENDIF
    2    CONTINUE
C     INITIAL PARAMETERS AND THEIR BOUNDS
      DO 4 I=1,NPAR
         PAR(I)=0.5
         PARL(I)=0.
         PARU(I)=1.
         POINT(I)=I
         POINTL(I)=0
    4    POINTU(I)=0
      NCONS=0
      NFIX=0
      NEST=NPAR
      CALL GETCMD
    5 IF (WORDS(1).EQ.'CONSTRAINT') THEN
         INDENT=2
         CALL CONSRT(1)
      ELSE IF (WORDS(1).EQ.'INITIAL') THEN
         INDENT=2
         CALL INITAL
      ELSE IF (WORDS(1).EQ.'PROC') THEN
         GO TO 10
      ELSE
         CALL ERROR('Unrecognized command after PROC ESTIMATE.')
         RETURN
      ENDIF
      GO TO 5
 10   INDENT=1
      CALL LINCHK(8)
      WRITE (UNIT=SYSOUT,FMT=
     1   '(/6X,33HNumber of parameters in model  = ,i3)') NPAR
      WRITE (UNIT=SYSOUT,FMT=
     1   '(/6X,33HNumber of parameters set equal = ,i3)') NCONS
      WRITE (UNIT=SYSOUT,FMT=
     1   '(/6X,33HNumber of parameters fixed     = ,i3)') NFIX
      WRITE (UNIT=SYSOUT,FMT=
     1   '(/6X,33HNumber of parameters estimated = ,i3)') NEST
      if(nest.gt.mxpar3) then
        call error('# estimable params exceeds dimensions')
        return
      end if
      CALL LINCHK(7+NPAR)
      WRITE(UNIT=SYSOUT,FMT='(////27X,14HLower    Upper)')
      WRITE(UNIT=SYSOUT,FMT=
     1  '(1X,47H  I   Parameter   S(I)    Bound    Bound  Label)')
      WRITE(UNIT=SYSOUT,FMT='(2X,3H---,2X,9(1H-),2X,6(1H-),2X,
     1 1X,5(1H-),4X,5(1H-),2X,20(1H-))')
      CALL MOVFLT(PAR,PPAR,NPAR)
C
C   LOOP TO PRINT INITIAL CONDITIONS
C
      DO 20 I=1,NPAR
         IF (POINTL(I).GT.0) THEN
            WRITE(LOWBND,FMT='(3X,2HS(,i3.3,1H))') POINTL(I)
            BNDL=PAR(POINTL(I))
         ELSE
            WRITE(LOWBND,FMT='(F8.3)') PARL(ABS(POINT(I)))
            BNDL=PARL(ABS(POINT(I)))
         ENDIF
         IF (POINTU(I).GT.0) THEN
            WRITE(UPPBND,FMT='(3X,2HS(,i3.3,1H))') POINTU(I)
            BNDU=PAR(POINTU(I))
         ELSE
            WRITE(UPPBND,FMT='(F8.3)') PARU(ABS(POINT(I)))
            BNDU=PARU(ABS(POINT(I)))
         ENDIF
         WRITE(UNIT=SYSOUT,
     1      FMT='(1X,I3,I8,1X,F10.3,1X,2(A8,1X),1X,A36)')
     2      I,POINT(I),PAR(ABS(POINT(I))),LOWBND,UPPBND,SLABEL(I)
         IF (BNDL.GT.BNDU .OR. BNDL.GT.PAR(ABS(POINT(I)))
     1      .OR. BNDU.LT.PAR(ABS(POINT(I)))) THEN
            CALL WARN(
     1      'Boundary error -- value reset to 0 < S(I) < 1.')
            POINTL(I)=0
            POINTU(I)=0
            PARL(ABS(POINT(I)))=0.
            PARU(ABS(POINT(I)))=1.
         ENDIF
         IF (POINT(I).GT.0) THEN
            IF (ABS(BNDL-PAR(POINT(I))).LT.0.01) THEN
               PAR(POINT(I))=BNDL+0.01
            ENDIF
            IF (ABS(BNDU-PAR(POINT(I))).LT.0.01) THEN
               PAR(POINT(I))=BNDU-0.01
            ENDIF
         ENDIF
   20    CONTINUE
C
C   LOOP TO SET VALUES OF PAR TO REFLECT BOUNDARIES
C   BUGS -- THIS LOOP DOES NOT HANDLE CONSTRAINTS OF THE TYPE
C           S(I) < S(J) PROPERLY
C
      IF (.NOT.NOTRAN) THEN
         DO 17 I=1,NEST
            DO 18 J=1,NPAR
               IF (POINT(J).EQ.I) GO TO 19
 18            CONTINUE
            CALL ERROR('ESTMAT code error 1')
 19         IF (POINTL(J).GT.0) THEN
               BNDL=PAR(POINTL(J))
            ELSE
               BNDL=PARL(POINT(J))
            ENDIF
            IF (POINTU(J).GT.0) THEN
               BNDU=PAR(POINTU(J))
            ELSE
               BNDU=PARU(POINT(J))
            ENDIF
            IF (SINTRN) THEN
               PPAR(I)=ASIN(((PAR(I)-BNDL)/(BNDU-BNDL)-0.5)*2.0)
            ELSE
               PPAR(I)=(PAR(I)-BNDL)/(BNDU-BNDL)
            ENDIF
 17         CONTINUE
         CALL MOVFLT(PPAR,PAR,NEST)
      ENDIF
      IF (DEBUG) THEN
         CALL LINCHK(2)
         CALL WARN('DEBUG output follows.')
         CALL LINCHK(NPAR/5+2)
         WRITE(UNIT=SYSOUT,FMT='(/6X,5H  I =,5(6X,I3,6X),
     1      10(:/11X,5(6X,I3,6X)))') (I,I=1,NPAR)
         CALL LINCHK(NPAR/5+2)
         WRITE(UNIT=SYSOUT,FMT='(/6X,5HPAR =,5G15.8,10(:/11X,5G15.8))')
     1      (PAR(I),I=1,NPAR)
         CALL LINCHK(NPAR/5+2)
         WRITE(UNIT=SYSOUT,FMT='(/6X,5HPARL=,5G15.8,10(:/11X,5G15.8))')
     1      (PARL(I),I=1,NPAR)
         CALL LINCHK(NPAR/5+2)
         WRITE(UNIT=SYSOUT,FMT='(/6X,5HPARU=,5G15.8,10(:/11X,5G15.8))')
     1      (PARU(I),I=1,NPAR)
         CALL LINCHK(NPAR/5+2)
         WRITE(UNIT=SYSOUT,FMT='(/6X,5HS(I)=,5G15.8,10(:/11X,5G15.8))')
     1      (SS(I),I=1,NPAR)
         CALL LINCHK(NPAR/33+2)
         WRITE(UNIT=SYSOUT,FMT='(/6X,7H    I =,33I3,5(:/13X,33I3))')
     1      (I,I=1,NPAR)
         CALL LINCHK(NPAR/33+2)
         WRITE(UNIT=SYSOUT,FMT='(/6X,7HPOINT =,33I3,5(:/13X,33I3))')
     1      (POINT(I),I=1,NPAR)
         CALL LINCHK(NPAR/33+2)
         WRITE(UNIT=SYSOUT,FMT='(/6X,7HPOINTL=,33I3,5(:/13X,33I3))')
     1      (POINTL(I),I=1,NPAR)
         CALL LINCHK(NPAR/33+2)
         WRITE(UNIT=SYSOUT,FMT='(/6X,7HPOINTU=,33I3,5(:/13X,33I3))')
     1      (POINTU(I),I=1,NPAR)
         CALL LINCHK(2)
         CALL WARN('End of DEBUG output.')
      ENDIF
      IF (SIMULT) RETURN
  16  IF (DEBUG) THEN
         CALL LINCHK(2)
         CALL WARN('DEBUG output follows.')
         CALL LINCHK(NPAR/5+2)
         WRITE(UNIT=SYSOUT,FMT='(/6X,5H  I =,5(6X,I3,6X),
     1      10(:/11X,5(6X,I3,6X)))') (I,I=1,NPAR)
         CALL LINCHK(NPAR/5+2)
         WRITE(UNIT=SYSOUT,FMT='(/6X,5HPAR =,5G15.8,10(:/11X,5G15.8))')
     1      (PAR(I),I=1,NPAR)
         CALL LINCHK(NPAR/5+2)
         WRITE(UNIT=SYSOUT,FMT='(/6X,5HPARL=,5G15.8,10(:/11X,5G15.8))')
     1      (PARL(I),I=1,NPAR)
         CALL LINCHK(NPAR/5+2)
         WRITE(UNIT=SYSOUT,FMT='(/6X,5HPARU=,5G15.8,10(:/11X,5G15.8))')
     1      (PARU(I),I=1,NPAR)
         CALL LINCHK(NPAR/5+2)
         WRITE(UNIT=SYSOUT,FMT='(/6X,5HS(I)=,5G15.8,10(:/11X,5G15.8))')
     1      (SS(I),I=1,NPAR)
         CALL LINCHK(NPAR/33+2)
         WRITE(UNIT=SYSOUT,FMT='(/6X,7H    I =,33I3,5(:/13X,33I3))')
     1      (I,I=1,NPAR)
         CALL LINCHK(NPAR/33+2)
         WRITE(UNIT=SYSOUT,FMT='(/6X,7HPOINT =,33I3,5(:/13X,33I3))')
     1      (POINT(I),I=1,NPAR)
         CALL LINCHK(NPAR/33+2)
         WRITE(UNIT=SYSOUT,FMT='(/6X,7HPOINTL=,33I3,5(:/13X,33I3))')
     1      (POINTL(I),I=1,NPAR)
         CALL LINCHK(NPAR/33+2)
         WRITE(UNIT=SYSOUT,FMT='(/6X,7HPOINTU=,33I3,5(:/13X,33I3))')
     1      (POINTU(I),I=1,NPAR)
         CALL LINCHK(2)
         CALL WARN('End of DEBUG output.')
      ENDIF
C   CHECK THAT THE CELL PROBABILITIES ADD TO UNITY
      CALL EST(NEST,PPAR,XLL)
      DO 31 J=1,NCOHT
          XLL=0.
          DO 33 K=1,NCLASS(J)
              XLL=XLL+P(K,J)
 33           CONTINUE
          IF (ABS(1.-XLL).GT.0.0001) THEN
              CALL WARN ('Cell probabilities do not sum to 1.0 for '//
     1                   'at least one cohort.')
              WRITE(UNIT=SYSOUT,FMT='(/5X,A,I3,A)') 'Cohort',J,
     1           ' does not sum to 1.0.'
              CALL WARN ('Results will be incorrect.')
              write(unit=sysout,fmt='(4hsum=,e14.6)')xll
              write(unit=sysout,fmt='(4hp  =,/(5e14.6))')
     1                 (p(k,j),k=1,nclass(j))
              CALL LINCHK(3)
          ENDIF
 31       CONTINUE
 34   IF (NEST.GT.0) THEN
         CALL OPTMIZ(EST,NEST,NSIG,MAXFN,IJOBOP,PPAR,H,G,XLL,W,IEROPT)
      ELSE
         IEROPT=0
         W(3,1)=14
         W(2,1)=0
      ENDIF
      CALL MOVFLT(PPAR,PAR,NEST)
      IF (DETAIL) THEN
      CALL LINCHK(6)
      WRITE(UNIT=SYSOUT,FMT='(/5X,21HFinal function value ,G14.8,
     1   17H (Error Return = ,I3,1H))') XLL,IEROPT
      WRITE(UNIT=SYSOUT,FMT=
     1   '(/5X,31HNumber of significant digits   ,I5)') INT(W(3,1))
      WRITE(UNIT=SYSOUT,FMT=
     1   '(/5X,31HNumber of function evaluations ,I5)') INT(W(2,1))
      ENDIF
      IF (IEROPT.NE.0) THEN
         IF (IEROPT.EQ.129) THEN
            CALL WARN('Hessian matrix was not initialized positive'//
     1           ' definite for Model '//MODNAM(MODNUM))
         ELSE IF (IEROPT.EQ.130) THEN
            CALL WARN('Rounding errors became dominant before'//
     1         ' parameters estimated')
            CALL WARN('to NSIG digits for Model '//MODNAM(MODNUM))
            CALL WARN('Check to be sure the parameters are '//
     1         'identifiable,')
            CALL WARN('but the problem may just be ill-conditioned.')
         ELSE IF (IEROPT.EQ.131) THEN
            CALL WARN('Number of function evaluations exceed MAXFN'//
     1      ' limit before')
            CALL WARN('parameters estimated to NSIG digits'//
     1         ' for Model '//MODNAM(MODNUM))
         ELSE
            CALL ERROR('Unknown error message from OPTMIZ subroutine.')
         ENDIF
      ENDIF
C
C   SET VALUES IN PAR TO BE ACTUAL PARAMETER VALUES,
C   NOT TRANSFORMED VALUES WITH CONSTRAINTS
C
      DO 21 I=1,NEST
         DO 22 J=1,NPAR
            IF (POINT(J).EQ.I) GO TO 23
 22         CONTINUE
         CALL ERROR('ESTMAT code error 2')
 23      PPAR(I)=SS(J)
 21      CONTINUE
      NOTRAN=.TRUE.
      CALL MOVFLT(PPAR,PAR,NEST)
C
C   SET CELL PROBABILITIES TO FINAL PARAMETER VALUES
C
      CALL EST(NEST,PPAR,XLL)
C
C   FILL PARPI (PARTIALS OF CELL PROBABILITIES WRT PARAMETERS)
C   WITH THE CELL PROBABILITIES FOR PARAMETER ESTIMATES
C   THEN THE P ARRAY CAN HOLD THE CELL PROBABILITIES FOR THE
C   THE PERTURBATED PARAMETER VALUES, AND THE NUMERICAL
C   PARTIALS CAN BE CALULATED
C
      DO 40 I=1,NEST
   40 CALL MOVFLT(P(1,1),PARPI(1,1,I),MXCLAS*MAXCHT)
C
C   NOW CALCULATE PARTIALS OF CELL PROBABILITIES WRT PARAMETERS
C
      DO 45 I=1,NEST
         PARVAL=PPAR(I)
         IF (PPAR(I).GT.0.00005) THEN
            PPAR(I)=PPAR(I)*0.9999
         ELSE
            PPAR(I)=SIGN(0.0001D0,PPAR(I))
         ENDIF
         CALL EST(NEST,PPAR,XLL)
         DO 50 J=1,NCOHT
            DO 55 K=1,NCLASS(J)
   55          PARPI(K,J,I)=(P(K,J)-PARPI(K,J,I))/(PARVAL-PPAR(I))
   50       CONTINUE
   45    PPAR(I)=PARVAL
C
C   SET CELL PROBABILITIES BACK TO VALUES FOR PARAMETER ESTIMATES
C   THESE VALUES ARE NEEDED FOR FORMATION OF INFORMATION MATRIX
C   IN THE ARRAY H
C
         CALL EST(NEST,PPAR,XLL)
C
C   CONSTRUCT INFORMATION MATRIX IN ARRAY H
C
      DO 60 L=1,NEST
         DO 65 M=1,NEST
            K=L*(L-1)/2+M
            H(K)=0.
            DO 70 I=1,NCOHT
               PARVAL=0.
               DO 75 J=1,NCLASS(I)
                  IF (P(J,I).GT.0. .AND. ABS(PARPI(J,I,L)).GT.0.
     1            .AND. ABS(PARPI(J,I,M)).GT.0.)
     2            PARVAL=PARVAL+PARPI(J,I,L)*PARPI(J,I,M)/P(J,I)
   75             CONTINUE
70             H(K)=H(K)+(N(I))*PARVAL
 65         CONTINUE
 60      CONTINUE
C
C   INVERT INFORMATION MATRIX IN H TO OBTAIN THE VARIANCE COVARIANCE
C   MATRIX IN H
C
      IF (NEST.GT.0) THEN
         CALL MATINV(H,G,IJOBIV,NEST,IERINV)
      ELSE
         IERINV=0
      ENDIF
      IF (IERINV.EQ.130) THEN
         CALL WARN('Variance-covariance matrix not positive-'//
     1      'definite for Model '//MODNAM(MODNUM))
         CALL WARN('Ignore standard errors and V-C matrix.')
            CALL WARN('Check to be sure the parameters are '//
     1         'identifiable, but the problem may just be '//
     2         'ill-conditioned.')
      ENDIF
C
C   PRINT THE ESTIMATES, STANDARD ERRORS, AND CONFIDENCE INTERVALS
C
      IF (DETAIL) THEN
         CALL LINCHK(6+NPAR)
cjeh
         WRITE(UNIT=SYSOUT,FMT='(/30X,17HResults for model,
     1         i3,1X,A)')modnum, MODNAM(MODNUM)
Cjeh
         WRITE(UNIT=SYSOUT,FMT='(///57X,23H95% Confidence Interval)')
         WRITE(UNIT=SYSOUT,FMT=
     1    '(1X,35H  I       Parameter            S(I),
     2    5x,14hStandard Error,4X,5HLower,9X,5HUpper)')
         WRITE(UNIT=SYSOUT,
     1      FMT='(2X,3(1H-),2X,20(1H-),4(1X,12H------------))')
      ENDIF
      DO 25 I=1,NPAR
         IF (POINT(I).GT.0) THEN
            SEPAR=SQRT(H(POINT(I)*(POINT(I)-1)/2+POINT(I)))
         ELSE
            SEPAR=0.
         ENDIF
         IF (DETAIL) THEN
            LCI=SS(I)-1.96*SEPAR
            UCI=SS(I)+1.96*SEPAR
cjeh        WRITE(UNIT=SYSOUT,FMT='(1X,I3,5X,I3,6X,G14.8,3(2X,G14.8))')
cjeh  1      I,POINT(I),SS(I),SEPAR,LCI,UCI
            WRITE(UNIT=SYSOUT,FMT='(2i4,1x,a20,G12.6,3(1X,G12.6))')
     1      I,POINT(I),SLABEL(I),SS(I),SEPAR,LCI,UCI
         ENDIF
         IF (SIMULT) THEN
            PPAR(I)=SEPAR
         ENDIF
   25    CONTINUE
C
C   PRINT VARIANCE-COVARIANCE MATRIX
C
      IF (DETAIL) THEN
      IF (.NOT. NOVAR) THEN
      CALL LINCHK(5)
      WRITE(UNIT=SYSOUT,FMT='(///6X,A//14X,A)')
     1  'Variance-Covariance matrix of estimates on diagonal and below,'
     2 ,'Correlation matrix of estimates above diagonal.'
      DO 27 I=1,NPAR
         DO 26 J=1,I
            VCMAT(I,J)=0.
            IF (POINT(I).GT.0 .AND. POINT(J).GT.0) THEN
               VCMAT(J,I)=H(POINT(I)*(POINT(I)-1)/2+POINT(J))
            ELSE
               VCMAT(J,I)=0.
            ENDIF
   26       CONTINUE
   27    CONTINUE
      CALL LINCHK(3+NPAR/6)
      WRITE(UNIT=SYSOUT,FMT='(31(/4X,1H|,I5,5I12))')
     1      (I,I=1,NPAR)
      WRITE(UNIT=SYSOUT,FMT='(5H ---+,6(A))')
     1   ('------------',I=1,MIN(6,NPAR))
      DO 29 I=1,NPAR-1
         DO 28 J=I+1,NPAR
            IF (VCMAT(I,I).GT.0. .AND. VCMAT(J,J).GT.0.) THEN
               VCMAT(J,I)=VCMAT(I,J)/SQRT(VCMAT(I,I)*VCMAT(J,J))
            ENDIF
   28       CONTINUE
         CALL LINCHK(2+NPAR/6)
         WRITE(UNIT=SYSOUT,FMT='(4X,1H|/1X,I3,1H|,6G12.5,30(/4X,1H|,
     1   6G12.5))') I,(VCMAT(J,I),J=1,NPAR)
   29    CONTINUE
         CALL LINCHK(2+NPAR/6)
         WRITE(UNIT=SYSOUT,FMT='(4X,1H|/1X,I3,1H|,6G12.5,30(/4X,1H|,
     1   6G12.5))') NPAR,(VCMAT(J,NPAR),J=1,NPAR)
      ENDIF
      CALL LINCHK(5)
      WRITE(UNIT=SYSOUT,FMT=
     1'(///54H   Cohort  Cell   Observed  Expected  Chi-square  Note/
     2 50H   ------  ----   --------  --------  ----------  ,13(1H-))')
      ENDIF
      NDF=0
      CHISQ=0.0
      NDFP=0
      CHISQP=0.0
      XLL=-XLL
      DO 35 I=1,NCOHT
         IF (.NOT. NOBINC) XLL=XLL+DLGAMA((N(I)+1))
         IF (DETAIL) THEN
         CALL LINCHK(NCLASS(I)+1)
         ENDIF
         DO 30 J=1,NCLASS(I)
            IF (.NOT. NOBINC) XLL=XLL-DLGAMA((OBS(J,I)+1))
            EXPECT(J)=(N(I))*P(J,I)
            OBSERV(J)=(OBS(J,I))
            IF(EXPECT(J).GT.10.**(-NSIG) .AND. OBSERV(J).GT.0.) THEN
               GCONTR=2.*LOG(OBSERV(J)/EXPECT(J))*OBSERV(J)
            ELSE
               GCONTR=0.
            ENDIF
            IF(EXPECT(J).GT.10.**(-NSIG)) THEN
               CONTRB=(OBSERV(J)-EXPECT(J))**2/EXPECT(J)
            ELSE
               CONTRB=0.
            ENDIF
            IF (DETAIL) THEN
            IF (P(J,I).LT.0. .OR. P(J,I).GT.1.) THEN
               NOTE='NOT 0 < P < 1'
            ELSE
               NOTE='0 < P < 1'
            ENDIF
            WRITE(UNIT=SYSOUT,FMT='(3X,I4,4X,I3,f9.0,1X,F11.3,1X,F10.3,
     1         3X,A)') I,J,OBS(J,I),EXPECT(J),CONTRB,NOTE
            ENDIF
   30       CHISQ=CHISQ+GCONTR
         NDF=NDF+NCLASS(I)-1
         NDFI=NCLASS(I)-1
         CALL CSPOOL(OBSERV,EXPECT,NDFI,NCLASS(I),CHISQI)
         CHISQP=CHISQP+CHISQI
         NDFP=NDFP+NDFI
         IF (DETAIL) THEN
            CALL CDTR(CHISQI,NDFI,PROB,IER)
            PROB=1.-PROB
            WRITE(UNIT=SYSOUT,
     1         FMT='(3X,I4,1X,A,I3,16X,F10.3,3X,A,F6.4)')
     2         I,'Cohort df=',NDFI,CHISQI,'P = ',PROB
         ENDIF
 35      CONTINUE
      IF (DETAIL) THEN
         WRITE(UNIT=SYSOUT,FMT='(3X,60(1H-))')
      ENDIF
      NDF=NDF-NEST
      NESTSV(MODNUM)=NEST
      NDFSAV(MODNUM)=NDF
      CALL CDTR(CHISQ,NDF,PROB,IER)
      IF (IER.NE.0) THEN
         CALL WARN('ERROR with chi-square probability.')
      ENDIF
      PROB=1.-PROB
      MODGOF(MODNUM)=PROB
      NDFP=NDFP-NEST
      WRITE(UNIT=SYSOUT,FMT='(2H@@,3I5,2(I4,1X,G13.6),2G13.6)')
     X   MODNUM,IEROPT,IERINV,NDF,CHISQ,NDFP,CHISQP,XLL,-2.*XLL+2*NEST
      IF (DETAIL) THEN
      CALL LINCHK(8)
      WRITE(UNIT=SYSOUT,FMT='(3X,29HG Total (Degrees of freedom =,I4,
     1   1H),1X,F11.3)') NDF,CHISQ
      WRITE(UNIT=SYSOUT,FMT='(3X,24HPr(Larger Chi-square) = ,F6.4)')PROB
      ENDIF
      GOFG(MODNUM)=CHISQ
      GOFDF(MODNUM)=NDF
      IF (NDFP.GT.0) THEN
      CALL CDTR(CHISQP,NDFP,PROB,IER)
      IF (IER.NE.0) THEN
         CALL WARN('ERROR with chi-square probability.')
      ENDIF
      PROB=1.-PROB
C     MODGOF(MODNUM)=PROB
      IF (DETAIL) THEN
      WRITE(UNIT=SYSOUT,FMT='(3X,''With pooling, Degrees of freedom =''
     1         ,I4,''  Pearson Chi-square ='',F11.3)') NDFP,CHISQP
      WRITE(UNIT=SYSOUT,FMT='(3X,24HPr(Larger Chi-square) = ,F6.4)')PROB
      ENDIF
      ENDIF
      IF (DETAIL) THEN
         WRITE(UNIT=SYSOUT,FMT='(//3X,''Log-likelihood = '',G14.8,4X,
     1   ''Akaike Information Criterion = '',G14.8)') XLL,
     2   -2.*XLL+2*NEST
      ENDIF
      XLLVAL(MODNUM)=XLL
      IF (SIMULT) RETURN
C   WRITE PARAMETER ESTIMATES TO DIRECT ACCESS FILE SYSTP2
C   FOR LATER USE IN RETAIN STATEMENTS
      IF (MODNUM.EQ.1) THEN
         CLOSE(UNIT=SYSTP2,STATUS='DELETE')
         OPEN(UNIT=SYSTP2,ACCESS='DIRECT',FORM='UNFORMATTED',
     1      RECL=MAXPAR*8,STATUS='SCRATCH')
      ENDIF
      WRITE(UNIT=SYSTP2,REC=MODNUM) (SS(I),I=1,NPAR)
      RETURN
      END

