      INTEGER MAXCHT,MXCLAS,MAXMOD,MAXPAR,MAXCHS
c      PARAMETER (MAXCHT=20,MXCLAS=160,MAXMOD=20,MAXPAR=50,MAXCHS=1320)
c      PARAMETER (MAXCHT=470,MXCLAS=21,MAXMOD=20,MAXPAR=614,MAXCHS=1320)
      PARAMETER (MAXCHT=250,MXCLAS=64,MAXMOD=50,MAXPAR=500,MAXCHS=1320)
      PARAMETER (MXPAR3=500)
C   WARNING -- MAXPAR MUST BE .GE. 11 TO ALLOW EQUIVALENCE STATEMENTS
C   IN ESTMAT AND SIMLTE TO WORK PROPERLY
C   ALSO MAXCHT * MXCLAS CANNOT BE .LT. MAXPAR
C   THE FOLLOWING 3 PARAMETERS ARE DEFINED AS FUNCTIONS OF OTHER PARAMETERS
C   AND ARE USED IN ESTMAT, IDENTF, AND SIMLTE SUBROUTINES.
      INTEGER MAXPR2,NSPACE,MAXMD2
      PARAMETER (MAXPR2=MXPAR3*(MXPAR3+1)/2)
      PARAMETER (NSPACE=MXPAR3*(MXPAR3+1)/2+MAXPAR+MXCLAS*MAXCHT*MXPAR3
     1                   -MXCLAS*MAXCHT-MAXPAR)
      PARAMETER (MAXMD2=MAXMOD*(MAXMOD-1)/2)
C   THE LARGEST COMMON BLOCK REQUIRED FOR /NOLABL/ IS DEFINED
C   IN THE FOLLOWING PARAMETER STATEMENT.
      PARAMETER (MAXCM=MAXPAR*(MAXPAR+1)/2+MAXPAR+MXCLAS*MAXCHT*MAXPAR)
C
      COMMON /SMODEL/ SFUNCS
      CHARACTER SFUNCS*1320
      COMMON /XLLSAV/ XLLVAL,GOFG,MODGOF,MODNUM,NDFSAV,NESTSV,GOFDF
      DOUBLE PRECISION XLLVAL(MAXMOD),MODGOF(MAXMOD),GOFG(MAXMOD)
      INTEGER MODNUM
      INTEGER*2 NDFSAV(MAXMOD),NESTSV(MAXMOD),GOFDF(MAXMOD)
      COMMON /NAMSAV/ MODNAM
      CHARACTER MODNAM(MAXMOD)*10
      COMMON /LMODEL/ SLABEL
      CHARACTER       SLABEL(MAXPAR)*80
C   * * *   WARNING   * * *   CHANGES TO /DMODEL/ AND /IMODEL/ MUST ALSO
C                             BE MADE IN WRITE STATEMENTS IN MODOUT.
      DOUBLE PRECISION PAR(MAXPAR),PARL(MAXPAR),PARU(MAXPAR),
     1                 P(MXCLAS,MAXCHT),N(MAXCHT),OBS(MXCLAS,MAXCHT)
      COMMON /DMODEL/ PAR,PARL,PARU,P
      INTEGER NCLASS(MAXCHT),NCOHT,NPAR,
     1      NCONS,NFIX,NEST,POINT(MAXPAR),POINTL(MAXPAR),POINTU(MAXPAR),
     2      NSIG,MAXFN,IEROPT,IERINV
      LOGICAL MODFLG,SINTRN,NOTRAN,NOVAR,NORMAL,NOBINC,ADDCEL
      COMMON /IMODEL/ OBS,N,NCLASS,NCOHT,NPAR,NCONS,NFIX,NEST,POINT,
     1    POINTL,POINTU,NSIG,MAXFN,MODFLG,SINTRN,NOTRAN,
     2    NOVAR,NORMAL,NOBINC,ADDCEL,IEROPT,IERINV
C
C   VARIABLE   DEFINITIONS
C   --------   -----------
C   MAXCHT     MAXIMUM NUMBER OF COHORTS
C   MXCLAS     MAXIMUM NUMBER OF CLASSES WITHIN A COHORT
C   MAXPAR     MAXIMUM NUMBER OF PARAMETERS ALLOWED
C   MAXCHS     MAXIMUM SIZE OF CHARACTER STRING ALLOWED
C   MAXMOD     MAXIMUM NUMBER OF MODELS ALLOWED IN MEMORY
C   SFUNCS     CHARACTER VARIABLE CONTAINING CODE FOR CELL PROBABILITY
C              TO BE SAVED ON DIRECT ACCES FILE IO UNIT SYSTP1
C   XLLVAL     ARRAY TO SAVE LOG LIKELIHOODS FOR EACH ESTIMATION
C   NDFSAV     ARRAY TO SAVE DEGREES OF FREEDOM FOR EACH ESTIMATION
C   MODNUM     POINTER INTO XLLVAL AND MODNAM FOR CURRENT ESTIMATION
C   MODNAM     ARRAY TO SAVE NAMES OF EACH MODEL FOR TESTING
C   OBS        NUMBER OF OBSERVED ANIMALS IN CELL
C   NCLASS     NUMBER OF CLASSES IN COHORT
C   NCOHT      NUMBER OF COHORTS
C   N          NUMBER OF ANIMALS AT START OF COHORT
C   NPAR       NUMBER OF PARAMETERS SPECIFIED IN MODEL
C   NCONS      NUMBER OF PARAMETERS CONSTRAINTED TO EQUAL ANOTHER
C              PARAMETER THAT IS BEING ESTIMATED
C   NFIX       NUMBER OF PARAMETERS FIXED TO A SPECIFIED VALUE
C   NEST       NUMBER OF PARAMETERS ACTUALLY BEING ESTIMATED
C   PAR        ARRAY OF PARAMETER VALUES
C   PARL       ARRAY OF PARAMETER LOWER BOUNDS (IF NEGATIVE POINTER TO PAR)
C   PARU       ARRAY OF PARAMETER UPPER BOUNDS (IF NEGATIVE POINTER TO PAR)
C   POINT      POINTER INTO PARAMETER ESTIMATES FOR USE IN CONSTRAINTS
C   POINTL     POINTER INTO PARAMETER ESTIMATES FOR LOWER CONSTRAINTS
C   POINTU     POINTER INTO PARAMETER ESTIMATES FOR UPPER CONSTRAINTS
C   P          CELL PROBABILITIES CALCULATED IN FUNCTION
C   NSIG       NUMBER OF SIGNIFICANT DIGITS TO USE IN ESTIMATES
C   MAXFN      MAXIMUM NUMBER OF FUNCTION EVALUATIONS
C   IEROPT     ERROR RETURN FROM OPTIMIZATION ROUTINE
C   IERINV     ERROR RETURN FROM MATRIX INVERSION ROUTINE
C   MODFLG     LOGICAL VARIABLE TO INDICATE IF A MODEL HAS BEEN
C              PROCESSED
C   SINTRN     LOGICAL VARIABLE INDICATING USE OF SIN TRANSFORMATION
C              FOR CONSTRAINT OF ESTIMATES TO A REGION
C   NOTRAN     LOGICAL VARIABLE INDICATING NO TRANSFORMATIONS
C              OR CONSTRAINTS
C   NOVAR      LOGICAL VARIABLE INDICATING TO NOT PRINT VARIANCE-COVARIANCE
C              MATRIX (SAVES PAPER)
C   NORMAL     LOGICAL VARIABLE INDICATING TO NORMALIZE CELL PROBABILITIES,
C              I.E., SUM VALUES AND DIVIDE EACH CELL BY SUM
C   NOBINC      FLAG TO NOT ADD BINOMIAL COEFFICIENT ONTO LOG LIKELIHOOD
C   ADDCEL      FLAG TO ADD 1-SUM AS LAST CELL PROBABILITY, WITH OBS=0
C

