      SUBROUTINE PRTCMD
      INCLUDE 'STATUS'
C   INDENT CONTROLS THE LEVEL OF INDENTATION
C   VALUE   INDENTATIONS AND CARRIAGE CONTROL
C   -----   ---------------------------------
C     1     TRIPLE SPACE NOT INDENTED
C     2     DOUBLE SPACE INDENTED 3 SPACES
C     3     SINGLE SPACE INDENTED 6 SPACES
C     4     SINGLE SPACE INDENTED 9 SPACES
C    NEG    SAME AS ABOVE BUT LEADING BLANKS ARE NOT ELIMINATED
      INTEGER VERIFY,I,ISTART,IEND
      EXTERNAL VERIFY
      CHARACTER*1 CONTRL(4),CCHAR
      CHARACTER*23 INPUTS
      INTEGER LINEED(4)
      DATA CONTRL/' ',' ',' ',' '/
      DATA INPUTS/' INPUT ---              '/
      DATA LINEED/2,1,0,0/
      IF (NOECHO .OR. LCMDED.LE.LCMDST) RETURN
      IF (INDENT.GE.0) THEN
         LCMDST=VERIFY(STRING(LCMDST:LCMDED),' ')+LCMDST-1
      ENDIF
      IF (LCMDST.LT.LCMDED) THEN
         CCHAR=CONTRL(MIN(4,ABS(INDENT)))
         CALL LINCHK(LINEED(MIN(ABS(INDENT),4)))
         IF (INDENT.EQ.1) WRITE(UNIT=SYSOUT,FMT='(2X)')
         IF (INDENT.LE.2) WRITE(UNIT=SYSOUT,FMT='(2X)')
         ISTART=LCMDST
 5       IEND=LCMDED
C        BREAK THE INPUT AT THE END OF A COMMENT
         IF (INDEX(STRING(ISTART:IEND),'*/') .GT. 0) THEN
            IEND=INDEX(STRING(ISTART:IEND),'*/')+ISTART
            IF (IEND+1.EQ.LCMDED) IEND=LCMDED
         ENDIF
C        BREAK THE INPUT AT THE END OF 60 COLUMNS, EVEN IF A COMMENT
         IF (IEND .GT. ISTART+59) THEN
            IEND=ISTART+59
C           FIND THE PREVIOUS BLANK TO BREAK UP THESE LONGER STATEMENTS
            DO 6 I=IEND,ISTART+1,-1
               IF (STRING(I:I).EQ.' ') GO TO 7
 6             CONTINUE
            I=IEND
 7          IEND=I
         ENDIF
         CALL LINCHK(1)
         WRITE(UNIT=SYSOUT,FMT='(3A)') CCHAR,
     1      INPUTS(1:11+MIN((ABS(INDENT)-1)*3,12)),STRING(ISTART:IEND)
         ISTART=IEND+1
         CCHAR=' '
         IF (IEND.NE.LCMDED) GO TO 5
      ENDIF
      RETURN
      END
