      SUBROUTINE SIMLTE
      INCLUDE 'STATUS'
      INCLUDE 'MODELC'
      INTEGER SAVCON(0:MAXMOD),SAVFIX(0:MAXMOD),SAVEST(0:MAXMOD),
     1   SAVSIG(0:MAXMOD),SAVMFN(0:MAXMOD),SAVPNT(MAXPAR,0:MAXMOD),
     2   SAVPTL(MAXPAR,0:MAXMOD),SAVPTU(MAXPAR,0:MAXMOD)
      LOGICAL SAVTRN(0:MAXMOD)
      DOUBLE PRECISION PPAR(MAXPAR),CUMPRB(0:MXCLAS),TESTBD(5)
      DOUBLE PRECISION SAVPAR(MAXPAR,0:MAXMOD),SAVPRL(MAXPAR,0:MAXMOD),
     1    SAVPRU(MAXPAR,0:MAXMOD)
      DOUBLE PRECISION SUMPAR(MAXPAR,MAXMOD),SSQPAR(MAXPAR,MAXMOD),
     1     SUMSEP(MAXPAR,MAXMOD),SSQSEP(MAXPAR,MAXMOD)
      DOUBLE PRECISION H(MAXPR2)
      DOUBLE PRECISION BNDL,BNDU,XLL,CHISQ,RANUM,PROB,XMEAN,SERROR
      DOUBLE PRECISION PARPI(MXCLAS,MAXCHT,MAXPAR)
      INTEGER NSIM,NUMMOD,NSAMP(0:MAXMOD)
      INTEGER LRPRLV(5,MAXMD2),GOFPRL(4,0:MAXMOD),SEED
      LOGICAL PAROUT,ERRTST
      CHARACTER PARFIL*30
      INTEGER IER,NDF,ISIM,INUM,IDEM,IVALUE,NONBLK,I,J,K,IJ
C   BLANK COMMON IS USED FOR COMMUNICATION WITH THE ESTMAT ROUTINE
      COMMON /NOLABL/ H,PPAR,PARPI
      DOUBLE PRECISION SS
      EXTERNAL EST,IVALUE,NONBLK,SS
      REAL RAN
      EXTERNAL RAN
      DATA TESTBD/0.01,0.05,0.10,0.50,1.0/,CUMPRB(0)/0./
C
C     TAKE CARE OF INITIALIZING SUMMARY STATISTICS
C
      DO 100 I=1,MAXMOD
         NSAMP(I)=0
         DO 105 J=1,4
  105    GOFPRL(J,I)=0
         DO 100 J=1,MAXPAR
            SUMPAR(J,I)=0.
            SSQPAR(J,I)=0.
            SUMSEP(J,I)=0.
            SSQSEP(J,I)=0.
  100       CONTINUE
      DO 110 I=1,MAXMD2
         DO 110 J=1,5
  110       LRPRLV(J,I)=0
C
C   TAKE CARE OF INFORMATION ON PROC SIMULATE CARD
C
      NSIM=5
      DETAIL=.FALSE.
      SEED=7654321
      PARFIL=' '
      PAROUT=.FALSE.
      ERRTST=.FALSE.
      DO 2 I=3,LSTWRD
         IF (WORDS(I).EQ.'NSIM') THEN
            NSIM = IVALUE(WORDS(I+2))
         ELSE IF (WORDS(I).EQ.'PARFILE') THEN
            PARFIL=WORDS(I+2)
            PAROUT=.TRUE.
         ELSE IF (WORDS(I).EQ.'DETAIL') THEN
            DETAIL=.TRUE.
         ELSE IF (WORDS(I).EQ.'SEED') THEN
            SEED = IVALUE(WORDS(I+2))
c            SEED = (SEED/2)*2+1
         ELSE IF (WORDS(I).EQ.'ERROR' .AND. WORDS(I+1).EQ.'TEST') THEN
            ERRTST = .TRUE.
        ENDIF
    2    CONTINUE
C
C   PROCESS INITIAL AND CONSTRAINT CARDS FOR PROC SIMULATE WITH
C   ESTMAT ROUTINE, BEING CAREFUL TO RESET MODNUM
C
      MODNUM=0
      CALL ESTMAT(1)
C
C   SAVE THE DETAILS OF THIS MODEL IN THE SAV--- AREAS
C   MODNUM OF 0 POINTS TO PARAMETER VALUES TO BE SIMULATED
C
      MODNUM=0
      SAVCON(MODNUM)=NCONS
      SAVFIX(MODNUM)=NFIX
      SAVEST(MODNUM)=NEST
      SAVSIG(MODNUM)=NSIG
      SAVMFN(MODNUM)=MAXFN
      SAVTRN(MODNUM)=SINTRN
      CALL MOVINT(POINT,SAVPNT(1,MODNUM),NPAR)
      CALL MOVINT(POINTL,SAVPTL(1,MODNUM),NPAR)
      CALL MOVINT(POINTU,SAVPTU(1,MODNUM),NPAR)
      CALL MOVFLT(PAR,SAVPAR(1,MODNUM),NPAR)
      CALL MOVFLT(PARL,SAVPRL(1,MODNUM),NPAR)
      CALL MOVFLT(PARU,SAVPRU(1,MODNUM),NPAR)
C
C   PROCESS PROC ESTIMATE CARDS TO DEFINE THE SUBMODELS
C
      DO 3 I=1,MAXMOD
         CALL ESTMAT(1)
C
C   SAVE THE DETAILS OF THIS MODEL IN THE SAV--- AREAS
C
         SAVCON(MODNUM)=NCONS
         SAVFIX(MODNUM)=NFIX
         SAVEST(MODNUM)=NEST
         SAVSIG(MODNUM)=NSIG
         SAVMFN(MODNUM)=MAXFN
         SAVTRN(MODNUM)=SINTRN
         CALL MOVINT(POINT,SAVPNT(1,MODNUM),NPAR)
         CALL MOVINT(POINTL,SAVPTL(1,MODNUM),NPAR)
         CALL MOVINT(POINTU,SAVPTU(1,MODNUM),NPAR)
         CALL MOVFLT(PAR,SAVPAR(1,MODNUM),NPAR)
         CALL MOVFLT(PARL,SAVPRL(1,MODNUM),NPAR)
         CALL MOVFLT(PARU,SAVPRU(1,MODNUM),NPAR)
         IF (WORDS(2).NE.'ESTIMATE') GO TO 4
 3       CONTINUE
      CALL ERROR('Number of PROC ESTIMATE calls exceeds dimensions.')
 4    NUMMOD=MODNUM
      IF (NUMMOD.LT.1) THEN
         CALL ERROR('No submodels specified in PROC SIMULATE.')
      ENDIF
      IF (PAROUT) THEN
         CLOSE(UNIT=SYSPRG,ERR=305)
         CALL LINCHK(6)
         WRITE(UNIT=SYSOUT,FMT='(//5X,A)')
     1   'Parameter estimates are written to the file '//PARFIL
         WRITE(UNIT=SYSOUT,FMT='(5X,A)')
     1   'with the order being Replicate Number, Model Number, and AIC'
         WRITE(UNIT=SYSOUT,FMT='(5X,A)')
     1   'The parameters follow on the next record(s) as'
         WRITE(UNIT=SYSOUT,FMT='(5X,A)')
     1   '(S(I),SE(S(I)),I=1,NPAR).'
         WRITE(UNIT=SYSOUT,FMT='(5X,A,I2)')
     1   'The format used is ''(8F10.6)'', which generates'
     2   //' (NPAR*2+2)/8+1 =',(NPAR*2+2)/8+1
         WRITE(UNIT=SYSOUT,FMT='(5X,A)')
     1   '''CARDS'' per model.'
         OPEN(UNIT=SYSPRG,FILE=PARFIL,STATUS='UNKNOWN',
     1   ACCESS='SEQUENTIAL',FORM='FORMATTED',ERR=305)
      ENDIF
      DO 30 ISIM=1,NSIM
c         WRITE(UNIT=SYSOUT,FMT='(6H ISIM=,I5,6H SEED=,I16)')ISIM,SEED
         DO 35 I=1,NCOHT
            DO 35 J=1,NCLASS(I)
               P(J,I)=0.
   35          OBS(J,I)=0.
C   SET PARAMETER ENVIRONMENT TO MODEL TO BE SIMULATED (MODNUM=0)
         MODNUM=0
         CALL MOVINT(SAVPNT(1,MODNUM),POINT,NPAR)
         CALL MOVINT(SAVPTL(1,MODNUM),POINTL,NPAR)
         CALL MOVINT(SAVPTU(1,MODNUM),POINTU,NPAR)
         CALL MOVFLT(SAVPAR(1,MODNUM),PPAR,NPAR)
         CALL MOVFLT(SAVPAR(1,MODNUM),PAR,NPAR)
         CALL MOVFLT(SAVPRL(1,MODNUM),PARL,NPAR)
         CALL MOVFLT(SAVPRU(1,MODNUM),PARU,NPAR)
         NEST=SAVEST(MODNUM)
         NFIX=SAVFIX(MODNUM)
         NCONS=SAVCON(MODNUM)
         NSIG=SAVSIG(MODNUM)
         MAXFN=SAVMFN(MODNUM)
         SINTRN=SAVTRN(MODNUM)
         NOTRAN=.FALSE.
C   GENERATE CELL PROBABILITIES FOR MODEL TO BE SIMULATED
         CALL EST(NEST,PPAR,XLL)
C
C              SIMULATE THE DATA
C
         
         CUMPRB(0)=0.
         DO 40 I=1,NCOHT
            DO 45 J=1,NCLASS(I)
            OBS(J,I)=0
 45         CUMPRB(J)=CUMPRB(J-1)+P(J,I)
            DO 50 K=1,int(N(I))
C   GENERATE A UNIFORM(0,1) RANDOM NUMBER
               RANUM=RAN(SEED)
               DO 55 J=1,NCLASS(I)
               IF (RANUM.GE.CUMPRB(J-1) .AND. RANUM.LT.CUMPRB(J)) THEN
                  OBS(J,I)=OBS(J,I)+1
                  GO TO 50
               ENDIF
 55            CONTINUE
 50         CONTINUE
            if(debug)write(sysout,'(f6.0,1h:,10f8.2)')n(i),
     ,           (obs(j,i),j=1,nclass(i))
 40      CONTINUE
C
C   PERFORM ESTIMATION FOR EACH OF THE PROC ESTIMATE CARDS
C
         DO 60 MODNUM=1,NUMMOD
            CALL MOVINT(SAVPNT(1,MODNUM),POINT,NPAR)
            CALL MOVINT(SAVPTL(1,MODNUM),POINTL,NPAR)
            CALL MOVINT(SAVPTU(1,MODNUM),POINTU,NPAR)
            CALL MOVFLT(SAVPAR(1,MODNUM),PPAR,NPAR)
            CALL MOVFLT(SAVPAR(1,MODNUM),PAR,NPAR)
            CALL MOVFLT(SAVPRL(1,MODNUM),PARL,NPAR)
            CALL MOVFLT(SAVPRU(1,MODNUM),PARU,NPAR)
            NEST=SAVEST(MODNUM)
            NFIX=SAVFIX(MODNUM)
            NCONS=SAVCON(MODNUM)
            NSIG=SAVSIG(MODNUM)
            MAXFN=SAVMFN(MODNUM)
            SINTRN=SAVTRN(MODNUM)
            NOTRAN=.FALSE.
            IF (DETAIL) THEN
               CALL HEADNG
               CALL LINCHK(4)
               I=MAX(NONBLK(MODNAM(MODNUM),10),1)
               WRITE(UNIT=SYSOUT,FMT=
     1           '(/7X,37HDetailed Simulation Output for MODEL ,A,
     2           18H Replicate Number ,I3//)')
     3           MODNAM(MODNUM)(1:I),ISIM
            ENDIF
            IF (DEBUG) THEN
               CALL LINCHK(2)
               CALL WARN('DEBUG output follows.')
               CALL LINCHK(3)
               WRITE(UNIT=SYSOUT,FMT='(//5X,A,I3)')
     1         'Listing of data generated for replicate ',ISIM
               DO 42 I=1,NCOHT
                  CALL LINCHK(2+NCLASS(I)/22)
                 WRITE(UNIT=SYSOUT,
     1              FMT='(/7H COHORT,I3,22I5:/10X,22I5)')
     2              I,(OBS(J,I),J=1,NCLASS(I))
 42               CONTINUE
               CALL LINCHK(2)
               CALL WARN('End of DEBUG output.')
            ENDIF
            CALL ESTMAT(3)
            IF (ERRTST .AND. (IEROPT.GT.0 .OR. IERINV.GT.0)) THEN
               NDFSAV(MODNUM)=-1
            ELSE
               NSAMP(MODNUM)=NSAMP(MODNUM)+1
               DO 25 I=1,NPAR
                  SUMPAR(I,MODNUM)=SUMPAR(I,MODNUM)+SS(I)
                  SSQPAR(I,MODNUM)=SSQPAR(I,MODNUM)+SS(I)**2
                  SUMSEP(I,MODNUM)=SUMSEP(I,MODNUM)+PPAR(I)
   25             SSQSEP(I,MODNUM)=SSQSEP(I,MODNUM)+PPAR(I)**2
               IF (PAROUT) THEN
                  WRITE(UNIT=SYSPRG,FMT='(2I10,G16.8)')
     1               ISIM,MODNUM,-2.*XLLVAL(MODNUM)+2*NESTSV(MODNUM)
                  WRITE(UNIT=SYSPRG,FMT='(8F10.6)')
     1               (SS(I),PPAR(I),I=1,NPAR)
               ENDIF
               DO 65 K=1,4
                  IF (MODGOF(MODNUM) .LT. TESTBD(K)) THEN
                     GOFPRL(K,MODNUM)=GOFPRL(K,MODNUM)+1
                  ENDIF
   65             CONTINUE
            ENDIF
   60       CONTINUE
      IF (DETAIL) THEN
         CALL HEADNG
         CALL LINCHK(5+NUMMOD)
         WRITE(UNIT=SYSOUT,FMT=
     1'(/6X,44HLikelihood Ratio Test Results for Replicate ,I3)')
     2      ISIM
         WRITE(UNIT=SYSOUT,FMT=
     1      '(/6X,8HSubmodel,4X,4HName,6X,19HLog-likelihood  NDF,
     2      2X,19HAkaike Inf. Criter.,3X,5HG-O-F)')
         WRITE(UNIT=SYSOUT,FMT=
     1      '(6X,8(1H-),2X,10(1H-),2X,14(1H-),2X,3(1H-),2X,
     2      19(1H-),2X,6(1H-))')
         DO 10 I=1,NUMMOD
           IF (NDFSAV(I).GE.0) THEN
              WRITE(UNIT=SYSOUT,FMT='(6X,I5,5X,A10,2X,G14.8,I5,5X,
     1           G14.8,4X,F6.4)')
     2           I,MODNAM(I),XLLVAL(I),NDFSAV(I),
     3           -2.*XLLVAL(I)+2*NESTSV(I),MODGOF(I)
            ELSE
               WRITE(UNIT=SYSOUT,FMT='(5X,I5,5X,A10,2X,A)')
     1            I,MODNAM(I),'Failed to converge properly.'
            ENDIF
   10    CONTINUE
      ENDIF
      IF (NUMMOD.GT.1) THEN
         IF (DETAIL) THEN
            CALL LINCHK(4)
            WRITE(UNIT=SYSOUT,FMT='(1X)')
            WRITE(UNIT=SYSOUT,FMT='(15X,A)')
     1      ' General     Reduced                Degrees   Pr(Larger ',
     2      ' Submodel    Submodel   Chi-square  Freedom  Chi-square)',
     3      '----------  ----------  ----------  -------  -----------'
         ENDIF
         IJ=0
         DO 83 I=1,NUMMOD-1
            IF (NDFSAV(I).EQ.-1) THEN
               IJ=IJ+NUMMOD-I
            ELSE
            DO 80 J=I+1,NUMMOD
               IJ=IJ+1
               IF (NDFSAV(J).EQ.-1) GO TO 80
               IF (NDFSAV(I).GT.NDFSAV(J)) THEN
                  INUM=I
                  IDEM=J
               ELSE IF (NDFSAV(I).LT.NDFSAV(J)) THEN
                  INUM=J
                  IDEM=I
               ELSE
                  GO TO 80
               ENDIF
               CHISQ=-2.*(XLLVAL(INUM)-XLLVAL(IDEM))
               NDF=NDFSAV(INUM)-NDFSAV(IDEM)
               IF (CHISQ.GT.0. .AND. NDF.GT.0) THEN
                  CALL CDTR(CHISQ,NDF,PROB,IER)
                  IF (IER.NE.0) THEN
                     CALL WARN('ERROR with chi-square probability.')
                  ENDIF
                  PROB=1.-PROB
               ELSE
                  PROB=1.
                  CHISQ=0.
               ENDIF
               DO 85 K=1,5
                  IF (PROB.LE.TESTBD(K)) THEN
                     LRPRLV(K,IJ)=LRPRLV(K,IJ)+1
                  ENDIF
   85             CONTINUE
               IF (DETAIL) THEN
                  CALL LINCHK(1)
                  WRITE(UNIT=SYSOUT,FMT=
     1               '(15X,A10,2X,A10,2X,F10.3,4X,I3,7X,F6.4)')
     3               MODNAM(IDEM),MODNAM(INUM),CHISQ,NDF,PROB
               ENDIF
   80       CONTINUE
            ENDIF
   83    CONTINUE
      ENDIF
   30 CONTINUE
      WRITE(UNIT=SYSOUT,FMT='(12H FINAL SEED=,I16)')SEED
      IF (NSIM.GT.1) THEN
         CALL HEADNG
         DO 200 MODNUM=1,NUMMOD
            CALL LINCHK(9+NPAR)
            WRITE(UNIT=SYSOUT,FMT=
     1            '(/20X,35HS I M U L A T I O N   R E S U L T S/16X,
     2            6HMODEL ,A,9H   NSIM = ,I4,15H   Converged = ,I4)')
     3            MODNAM(MODNUM), NSIM, NSAMP(MODNUM)
            WRITE(UNIT=SYSOUT,FMT=
     1   '(//8X,4HMEAN,13X,2HSE,16X,9H95% C. I.)')
            WRITE(UNIT=SYSOUT,FMT=
     1   '(2X,1HI,3X,2(8HS(I)-Hat,8X),5HLower,9X,5HUpper)')
            WRITE(UNIT=SYSOUT,FMT='(1X,78(1H-)/)')
            IF (NSAMP(MODNUM).GT.0) THEN
            DO 90 I=1,NPAR
               XMEAN=SUMPAR(I,MODNUM)/DBLE(NSAMP(MODNUM))
               SERROR=0.
               IF (NSAMP(MODNUM).GT.1) THEN
                  SERROR=(((SSQPAR(I,MODNUM)-SUMPAR(I,MODNUM)*
     1               SUMPAR(I,MODNUM)/DBLE(NSAMP(MODNUM)))
     2               /DBLE(NSAMP(MODNUM)-1))/DBLE(NSAMP(MODNUM)))
                  IF(SERROR.GT.0.)SERROR=SQRT(SERROR)
               ENDIF
               BNDL=XMEAN-1.96*SERROR
               BNDU=XMEAN+1.96*SERROR
               WRITE(UNIT=SYSOUT,FMT='(1X,I2,4G15.8,1X,A)')
     1            I,XMEAN,SERROR,BNDL,BNDU,SLABEL(I)(1:16)
   90          CONTINUE
            CALL LINCHK(6+NPAR)
            WRITE(UNIT=SYSOUT,FMT=
     1         '(//9X,4HMEAN,12X,2HSE,17X,9H95% C. I.)')
            WRITE(UNIT=SYSOUT,FMT=
     1   '(2X,1HI,2X,2(12HSE(S(I)-Hat),3X),3X,5HLower,10X,5HUpper)')
            WRITE(UNIT=SYSOUT,FMT='(1X,78(1H-)/)')
            DO 95 I=1,NPAR
               XMEAN=SUMSEP(I,MODNUM)/DBLE(NSAMP(MODNUM))
               SERROR=0.
               IF (NSAMP(MODNUM).GT.1) THEN
                  SERROR=(((SSQSEP(I,MODNUM)-SUMSEP(I,MODNUM)*
     1               SUMSEP(I,MODNUM)/DBLE(NSAMP(MODNUM)))
     2                /DBLE(NSAMP(MODNUM)-1))/DBLE(NSAMP(MODNUM)))
                  IF(SERROR.GT.0.)SERROR=SQRT(SERROR)
               ENDIF
               BNDL=XMEAN-1.96*SERROR
               BNDU=XMEAN+1.96*SERROR
               WRITE(UNIT=SYSOUT,FMT='(1X,I2,4G15.8,1X,A)')
     1            I,XMEAN,SERROR,BNDL,BNDU,SLABEL(I)(1:16)
   95          CONTINUE
               CALL LINCHK(6)
               WRITE(UNIT=SYSOUT,
     1         FMT='(//21X,33HResults of Goodness of Fit Tests ,
     1         /23X,4(3H  <,F4.2)/22X,30(1H-)/23X,4I7)')
     2         (TESTBD(K),K=1,4),(GOFPRL(K,MODNUM),K=1,4)
            ELSE
               CALL WARN('Too few successful simulations to summarize.')
            ENDIF
  200       CONTINUE
      IF (NUMMOD.GT.1) THEN
      CALL HEADNG
      CALL LINCHK(8)
      WRITE(UNIT=SYSOUT,FMT='(//26X,
     1      29HLikelihood Ratio Test Results///37X,
     1      5(3H  <,F4.2)/11X,62(1H-))') (TESTBD(K),K=1,5)
      IJ=0
      DO 215 I=1,NUMMOD-1
         DO 215 J=I+1,NUMMOD
            IJ=IJ+1
            CALL LINCHK(1)
            WRITE(UNIT=SYSOUT,FMT='(12X,A10,5H VS. ,A10,5I7)')
     1            MODNAM(I),MODNAM(J),(LRPRLV(K,IJ),K=1,5)
  215    CONTINUE
      ENDIF
      ENDIF
      MODNUM=0
      DETAIL=.TRUE.
      RETURN
 305  CALL ERROR(
     1   'Error opening the binary file for parameter estimates.')
      RETURN
      END

