      SUBROUTINE MODEL
      INCLUDE 'STATUS'
      INCLUDE 'MODELC'
      INTEGER COUNT,IVALUE,I,II1,II2
      EXTERNAL COUNT,IVALUE
      LOGICAL INLINE
      INTEGER IISTR
      CHARACTER*80 STRNG(200)
      NCOHT=0
      NPAR=0
      NCONS=0
      NORMAL=.FALSE.
      ADDCEL=.FALSE.
      IISTR=0
      INLINE=.FALSE.
C   OPEN UP DIRECT ACCESS FILE TO HOLD CHARACTER EXPRESSIONS FOR
C   CELL PROBABILITIES
      CLOSE(UNIT=SYSTP1,STATUS='delete')
      OPEN(UNIT=SYSTP1,ACCESS='DIRECT',FORM='FORMATTED',
     1   RECL=MAXCHS,STATUS='SCRATCH')
      DO 5 I=3,LSTWRD
         IF (WORDS(I).EQ.'NPAR') THEN
            NPAR = IVALUE(WORDS(I+2))
            IF (NPAR.GT.MAXPAR)
     1      CALL ERROR('NPAR exceeds MAXPAR.  '//
     2      'Recompile with MAXPAR = NPAR in PARAMETER statement.')
         ELSE IF (WORDS(I).EQ.'NORMALIZE') THEN
            NORMAL=.TRUE.
         ELSE IF (WORDS(I).EQ.'ADDCELL') THEN
            ADDCEL=.TRUE.
         ENDIF
    5    CONTINUE
   10 DO 7 I=1,MAXPAR
         SLABEL(I)=' '
         WRITE(SLABEL(I),FMT='(10HPARAMETER ,I2)') I
    7    CONTINUE
      CALL GETCMD
   20 CONTINUE
      IF (WORDS(1).EQ.'PROC') THEN
         INDENT=1
         CALL MODOUT(iistr,strng)
         MODNUM=0
         RETURN
      ELSE IF (WORDS(1).EQ.'INLINE') THEN
         INDENT=2
         IISTR=IISTR+1
         STRNG(IISTR)=' '
         INLINE=.TRUE.
         I3=0
         IF(WORDS(2)(1:4).EQ.'DECL')THEN
            I3=1
            STRNG(IISTR)='@'
         END IF
c         write(*,*)words(1),' lstwrd=',lstwrd,':',words(lstwrd)
         DO I1=I3+2,LSTWRD
            DO I2=1,10
              IF(WORDS(I1)(I2:I2).NE.' ')THEN
                 I3=I3+1
                 STRNG(IISTR)(I3:I3)=WORDS(I1)(I2:I2)
              END IF
            END DO
         END DO
         CALL GETCMD
      ELSE IF (WORDS(1).EQ.'LABELS' .OR. WORDS(1).EQ.'LABEL') THEN
         INDENT=2
         INLINE=.FALSE.
         CALL LABELS
      ELSE IF (WORDS(1).EQ.'COHORT') THEN
         INDENT=2
         INLINE=.FALSE.
         NCOHT=NCOHT+1
         IF (NCOHT.GT.MAXCHT)
     1   CALL ERROR('Number of cohorts exceeds MAXCHT.'//
     2   '   Recompile with MAXCHT = # cohorts.')
         N(NCOHT) = VALUE(WORDS(3))
         NCLASS(NCOHT)=0
         IF(WORDS(4).NE.':')THEN
           DO I=4,LSTWRD
             NCLASS(NCOHT)=NCLASS(NCOHT)+1
             IF (NCLASS(NCOHT).GT.MXCLAS)
     1       CALL ERROR('Number of classes exceeds MXCLAS.'//
     2     '   Recompile with MXCLAS = # classes.')
             OBS(NCLASS(NCOHT),NCOHT) = VALUE(WORDS(I))
           END DO
         END IF
         CALL GETCMD
      ELSE
         INDENT=3
           NCLASS(NCOHT)=NCLASS(NCOHT)+1
           IF (NCLASS(NCOHT).GT.MXCLAS)
     1     CALL ERROR('Number of classes exceeds MXCLAS.'//
     2     '   Recompile with MXCLAS = # classes.')
           OBS(NCLASS(NCOHT),NCOHT) = VALUE(WORDS(1))
           SFUNCS=' '
           k=0
           DO I=3,LSTWRD
             do j=1,10
               if(words(i)(j:j).ne.' ')then
                 k=k+1
                 sfuncs(k:k)=words(i)(j:j)
               endif
             enddo
c15           SFUNCS(II1:II2)=WORDS(I)
           enddo
           IF (COUNT(SFUNCS,'(') .NE.COUNT(SFUNCS,')'))then
              CALL ERROR('Imbalanced parentheses in probability '//
     x                    'expression.')
              STOP 'Imbalanced parentheses in probability expression.'
           end if
           CALL GETCMD
           WRITE(UNIT=SYSTP1,REC=(NCOHT-1)*MXCLAS+NCLASS(NCOHT),
     1        FMT='(A)') SFUNCS
      ENDIF
      GO TO 20
      END
      
