      SUBROUTINE SAMSIZ(SBAR,SPBAR,FBAR,CVS,CVSP,K,N,M)
      IMPLICIT DOUBLE PRECISION (A-H,O-Z)
      DOUBLE PRECISION CSTAR(20),RSTAR(20),TSTAR(20),A,B,C,AP,H,RN,RM
      INTEGER*4 K,N,M,I
      N=0
      M=0
      IF (K.LT.2) THEN
         CALL ERROR('K < 2')
      ELSE IF (K .GT. 20) THEN
         CALL ERROR('K > 20')
      ELSE IF (SBAR .LE. 0. .OR. SBAR .GE. 1. .OR. SPBAR .LE. 0. .OR.
     +      SPBAR .GE. 1. .OR. FBAR .LE. 0. .OR. FBAR .GT. 1.) THEN
         CALL ERROR('Probabilities incorrect for sample size estimation'
     1    )
      ELSE
         DO 10 I=1,K
            CSTAR(I)=FBAR*(1.-SBAR**I)/(1.-SBAR)
   10       RSTAR(K-I+1)=CSTAR(I)
         TSTAR(1)=RSTAR(1)
         DO 15 I=2,K
   15       TSTAR(I)=TSTAR(I-1)-CSTAR(I-1)+RSTAR(I)
         A=0.
         B=0.
         C=1./RSTAR(1)+1./FBAR-2.
         AP=0.
         DO 20 I=1,K-1
            A=A+1./(TSTAR(I)-CSTAR(I))
            B=B+1./TSTAR(I)
   20       AP=AP+1./CSTAR(I)
         H=(A-B+C)/DBLE((K-1)**2)
         RN=H/CVS**2
         RM=(AP/SPBAR - DBLE(K-1))/((DBLE(K-1)*CVSP)**2
     +     - (AP-DBLE(K-1))/RN)
         N=INT(RN+0.5)
         M=INT(RM+0.5)
      ENDIF
      RETURN
      END
