      DOUBLE PRECISION FUNCTION SS(I)
      INCLUDE 'STATUS'
      INCLUDE 'MODELC'
      INTEGER I
      DOUBLE PRECISION BNDL, BNDU
      IF (I.GT.NPAR) THEN
         WRITE(UNIT=SYSOUT,FMT='(/11X,2HI=,I10,5HNPAR=,I10)') I,NPAR
         CALL ERROR('S(I) IN CELL PROBABILITY WITH I > NPAR')
      ENDIF
      IF (POINT(I).LT.0) THEN
C        NEGATIVE POINT(I) INDICATES A FIXED PARAMETER
         SS=PAR(ABS(POINT(I)))
      ELSE IF (NOTRAN) THEN
         SS=PAR(POINT(I))
      ELSE IF (SINTRN) THEN
         IF(POINTL(I).GT.0) THEN
            BNDL=(0.5*SIN(PAR(POINTL(I)))+0.5)
         ELSE
            BNDL=PARL(POINT(I))
         ENDIF
         IF(POINTU(I).GT.0) THEN
            BNDU=(0.5*SIN(PAR(POINTU(I)))+0.5)
         ELSE
            BNDU=PARU(POINT(I))
         ENDIF
         arg=PAR(POINT(I))
         if(abs(arg).gt.1.e15)arg=1.e15
         SS=(BNDU-BNDL)*(0.5*SIN(arg)+0.5)+BNDL
      ELSE
         IF(POINTL(I).GT.0) THEN
            BNDL=ABS(PAR(POINTL(I)))-DBLE(INT(ABS(PAR(POINTL(I)))))
         ELSE
            BNDL=PARL(POINT(I))
         ENDIF
         IF(POINTU(I).GT.0) THEN
            BNDU=ABS(PAR(POINTU(I)))-DBLE(INT(ABS(PAR(POINTU(I)))))
         ELSE
            BNDU=PARU(POINT(I))
         ENDIF
         SS=(BNDU-BNDL)*(ABS(PAR(POINT(I)))-
     1      DBLE(INT(ABS(PAR(POINT(I))))))+BNDL
      ENDIF
      RETURN
      END

