      IMPLICIT DOUBLE PRECISION (A-H,O-Z)
      INTEGER MAXWRD,MAXCHR
      PARAMETER (MAXWRD=240,MAXCHR=1320)
      COMMON /INSTR/  STRING,WORDS
      CHARACTER*1320  STRING
      CHARACTER*10    WORDS(MAXWRD)
      COMMON /STATUS/ LSTWRD,NXTCHR,LSTCHR,SYSIN,SYSOUT,SYSPRG,EOF,
     1                LCMDST,LCMDED,INDENT,NPAGE,LINES,CPLFLG,DEBUG,
     2                SIMULT,DETAIL,NOECHO,SYSTP1,TSTART,TSTOP,TCUMUL,
     3                SYSTP2,MAXLIN,BMDCAL
      INTEGER         LSTWRD,NXTCHR,LSTCHR,SYSIN,SYSOUT,SYSPRG,LCMDST,
     1                LCMDED,INDENT,NPAGE,LINES,SYSTP1,SYSTP2,MAXLIN
      LOGICAL         EOF,CPLFLG,DEBUG,SIMULT,DETAIL,NOECHO,BMDCAL
      REAL TSTART,TSTOP,TCUMUL
      REAL SECNDS
      EXTERNAL SECNDS
C
C   VARIABLE   DEFINITION
C   --------   ----------
C   STRING     CHARACTER ARRAY TO HOLD INPUT STREAM
C   WORDS      NEXT COMMAND IN STRING IS BROKEN INTO WORDS IN THIS ARRAY
C   LSTWRD     POINTER TO LAST ARRAY ELEMENT USED IN ARRAY WORDS
C   NXTCHR     POINTER TO NEXT COMMAND IN STRING
C   LSTCHR     POINTER TO LAST CHARACTER USED IN STRING
C   EOF        END-OF-FILE INDICATOR FOR FILE WITH IO UNIT SYSIN
C   SYSIN      IO UNIT FOR INPUT OF DATA AND MODEL
C   SYSOUT     IO UNIT FOR PRINTER OUTPUT
C   SYSPRG     IO UNIT FOR CREATING FORTRAN 77 SUBROUTINE FOR MODEL
C   LCMDST     POINTER INTO STRING FOR FOR STARTING CHARACTER OF
C              COMMAND CURRENTLY BEING PROCESSED
C   LCMDED     POINTER INTO STRING FOR FOR ENDING CHARACTER OF
C              COMMAND CURRENTLY BEING PROCESSED
C   INDENT     INDENTATION CONTROL VALUE (1-4 LEVELS OF INDENTATION)
C   NPAGE      CURRENT PAGE NUMBER
C   LINES      NUMBER OF LINES LEFT ON THE PAGE
C   SYSTP1     IO UNIT FOR DIRECT ACCESS FILE TO SAVE
C              CELL PROBABILITY EXPRESSIONS
C   SYSTP2     IO UNIT FOR DIRECT ACCESS FILE TO SAVE
C              OLD PARAMETER VALUES
C   DEBUG      FLAG TO GENERATE ADDITIONAL OUTPUT ON SYSOUT TO HELP
C              DEBUG THE PROGRAM
C   SIMULT     LOGICAL FLAG TO INDICATE CURRENT EXECUTION PART OF
C              A PROC SIMULATE CALL
C   BMDCAL     LOGICAL FLAG TO INDICATE PROC BMDPAR HAS BEEN ENTERED
C   NOECHO     LOGICAL FLAG TO NOT ECHO THE INPUT ON THE OUTPUT LISTING
C   TSTART     CPU TIME IN SECONDS FOR START OF CURRENT PROCEDURE
C   TSTOP      CPU TIME IN SECONDS FOR END OF CURRENT PROCEDURE
C   TCUMUL     CUMULATIVE CPU TIME IN SECONDS FOR CURRENT JOB
C
